* full sample with interactions;
/*proc means data=gmm91; var dlow dmed dhigh switch hyball hybnon nonh904 stay904 leav904 join904  lyld97 hyb97 hyb04 h9704 h97ft97 h04ft97 h97h04ft97 h97ft04 h04ft04 h97h04ft04 fertkgac97 fertkgac04;  run; 
proc means data=gmm91; 
*/

data gmm91a; set gmm91; *where switch=1; *if fertkgac97<600;
if nonh904=0; 
if dmed=1; 
*if 10<yld97<3000; 
*if 10<yld04<3000; 
*if dhiv=0; 
*if 10<yld97<5000; 
*if 10<yld04<5000; 

if seedkgac97=. then seedkgac97=1; 
if seedkgac97<1 then seedkgac97=1; 
if seedkgac04<1 then seedkgac04=1; *if dlow=0; 
if seedkgac97>35 then seedkgac97=35;
if seedkgac04>35 then seedkgac04=35;

*if fertkgac97<600; 
*if fertkgac97>200 then fertkgac97=200;
*if fertkgac04>200 then fertkgac04=200;
if fertcstac97<30000; 

*fertkgac97=fertaiac97;
*fertkgac04=fertaiac04;
*if fertkgac97>10000 then fertkgac97=15000;
*if fertkgac04>10000 then fertkgac04=15000;
fertkgac97=fertcstac97;
fertkgac04=fertcstac04;
if fertkgac97>8000 then fertkgac97=8000;
if fertkgac04>8000 then fertkgac04=8000;

h97ft97=hyb97*fertkgac97;
h04ft97=hyb04*fertkgac97;
h97h04ft97=hyb97*hyb04*fertkgac97;
h97ft04=hyb97*fertkgac04;
h04ft04=hyb04*fertkgac04;
h97h04ft04=hyb97*hyb04*fertkgac04;

*hlcostac04=hhrsac04; 

*if dhiv=0; 
/*
if fhrsac97>1200 then fhrsac97=1200;
if fhrsac04>1200 then fhrsac04=1200;
if hlcostac97>10000 then hlcostac97=10000;
if hlcostac04>10000 then hlcostac04=10000; 
if lpcostac97>5000 then lpcostac97=5000;
if lpcostac04>5000 then lpcostac04=5000; 
*/
proc chart data=gmm91a; hbar seedkgac97 seedkgac04 fhrsac97 fhrsac04 hlcostac97 hlcostac04 yld97 yld04 fertkgac97 fertkgac04; run;

proc means data=gmm91a; var yld97 yld04 sfmcost04 lpcostac97 lpcostac04 dlow dhiv dfert97 dfert04 yld97 yld04 dlow dmed dhigh switch hyball hybnon nonh904 stay904 leav904 join904  lyld97 hyb97 hyb04 h9704 h97ft97 h04ft97 h97h04ft97 h97ft04 h04ft04 h97h04ft04 fertkgac97 fertkgac04;  
*where dlow=1; run; 
proc means data=gmm91a; var hyb97 hyb04 h9704 h97ft97 h04ft97 h97h04ft97 h97ft04 h04ft04 h97h04ft04 fertkgac97 fertkgac04; 
output out=mvars mean = mhyb97 mhyb04 mh9704 mh97ft97 mh04ft97 
 mh97h04ft97 mh97ft04 mh04ft04 mh97h04ft04 mfertkgac97 mfertkgac04;run; 
data mvars1; set mvars; drop _type_; run;
proc means data=mvars1; run;

proc model data=gmm91a; 
endogenous lyld97 lyld04; 
lyld97 = del97 + gam1* hyb97 + gam2*hyb04 /*+ gam3*h9704*/
+ gam4*h97ft97
+ gam5*h04ft97 + gam6*h97h04ft97 + gam7*h97ft04 + gam8*h04ft04
+ gam9*h97h04ft04 /*+ gam10*fertkgac97 + gam11*fertkgac04*/
+ aseed97*seedkgac97 + aflab97*fhrsac97 + ahlab97*hlcostac97 + alp97*lpcostac97 + ac97*log(acresm97) + m97*log(main97)
+ hyb97*(haseed97*seedkgac97 + haflab97*fhrsac97 + hahlab97*hlcostac97 + halp97*lpcostac97 + hac97*(acresm97) + hm97*(main97))
+ aboy97*boy97 + agirl97*girl97 + aman97*man97 + aoman97*oman97 + awom97*wom97 + ahhs97*hhsize97;

lyld04 = del04 + gam12* hyb97 + gam22*hyb04 /*+ gam32*h9704 */
+ gam42*h97ft97 + gam52*h04ft97
+ gam62*h97h04ft97 + gam72*h97ft04 + gam82*h04ft04 + gam92*h97h04ft04
/*+ gam102*fertkgac97 + gam112*fertkgac04*/ + aseed04*seedkgac04
+ aflab04*fhrsac04+ ahlab04*hlcostac04+ alp04*lpcostac04+ ac04*log(acresm04) + m04*log(main04)
+ hyb04*(haseed04*seedkgac04 + haflab04*fhrsac04 + hahlab04*hlcostac04 + halp04*lpcostac04 + hac04*(acresm04) + hm04*(main04))
+ aboy04*boy04+ agirl04*girl04+ aman04*man04+ aoman04*oman04+ awom04*wom04+ ahhs04*hhsize04;
test haseed97,haflab97,hahlab97,halp97,hac97,hm97;
test haseed04,haflab04,hahlab04,halp04,hac04,hm04;
test haseed97,haflab97,hahlab97,halp97,hac97,hm97,haseed04,haflab04,hahlab04,halp04,hac04,hm04;
fit lyld97 lyld04 /sur outest=gparmh outv=gcovh; run;

data gparmhm; merge gparmh mvars1; run;

proc model data=gmm91a parmsdata=gparmhm; 
endogenous lyld97 lyld04 ;
parms del97 del04 afert97 afert04 lam0 lam1 lam2 lam3 lam4 lam5 lam6 lam7 lam8 lam9 lam10 lam11 phi b0 gam1 gam2 gam3 gam4 gam5 gam6 gam7 gam8 gam9 gam10 gam11
gam12 gam22 gam32 gam42 gam52 gam62 gam72 gam82 gam92 gam102 gam112
mhyb97 mhyb04 mh9704 mh97ft97 mh04ft97 
 mh97h04ft97 mh97ft04 mh04ft04 mh97h04ft04 mfertkgac97 mfertkgac04;

lyld97 = del97 + (lam1*(1+phi)+ b0 + phi*(lam0))* hyb97
+ lam2*hyb04 + (phi*lam2+(1+phi)*lam3)*h9704 + ((1+phi)*lam4 + phi*lam10)*h97ft97
+ lam5*h04ft97 + ((1+phi)*lam6 + phi*lam5)*h97h04ft97 + ((1+phi)*lam7 + phi*lam11)*h97ft04 + lam8*h04ft04 
+ ((1+phi)*lam9 + phi*lam8)*h97h04ft04 + (lam10+afert)*fertkgac97 + lam11*fertkgac04  + aseed97*seedkgac97
+ aflab97*fhrsac97 + ahlab97*hlcostac97 + alp97*lpcostac97 + ac97*log(acresm97) + m97*log(main97)
+ aboy97*boy97 + agirl97*girl97 + aman97*man97 + aoman97*oman97 + awom97*wom97 + ahhs97*hhsize97;

lyld04 = del04 + lam1* hyb97 
+ (lam2*(1+phi)+b0 +phi*(lam0))*hyb04 
+ (phi*lam1+(1+phi)*lam3)*h9704 + lam4*h97ft97 + ((1+phi)*lam5 + phi*lam10)*h04ft97
+ ((1+phi)*lam6+phi*lam4)*h97h04ft97 + lam7*h97ft04 + ((1+phi)*lam8 + phi*lam11)*h04ft04 + ((1+phi)*lam9 + phi*lam7)*h97h04ft04
+ lam10*fertkgac97 + (lam11+afert)*fertkgac04  + aseed04*seedkgac04
+ aflab04*fhrsac04+ ahlab04*hlcostac04+ alp04*lpcostac04+ ac04*log(acresm04) + m04*log(main04)
+ aboy04*boy04+ agirl04*girl04+ aman04*man04+ aoman04*oman04+ awom04*wom04+ ahhs04*hhsize04;

lyld97c = del97 + lam2*hyb04 + lam5*h04ft97 + lam8*h04ft04 + (lam10+afert)*fertkgac97 + lam11*fertkgac04  
+ aseed97*seedkgac97 + aflab97*fhrsac97 + ahlab97*hlcostac97 + alp97*lpcostac97 + ac97*log(acresm97) 
+ m97*log(main97) + aboy97*boy97 + agirl97*girl97 + aman97*man97 + aoman97*oman97 + awom97*wom97 + ahhs97*hhsize97;

lyld04c = del04 + lam1* hyb97 + lam4*h97ft97 + lam7*h97ft04 + lam10*fertkgac97 + (lam11+afert)*fertkgac04  
+ aseed04*seedkgac04 + aflab04*fhrsac04+ ahlab04*hlcostac04+ alp04*lpcostac04+ ac04*log(acresm04) 
+ m04*log(main04) + aboy04*boy04+ agirl04*girl04+ aman04*man04+ aoman04*oman04+ awom04*wom04+ ahhs04*hhsize04;

ptheta=phi*theta; 
restrict lam0=-mhyb97*lam1- mhyb04*lam2- mh9704*lam3 - mh97ft97*lam4
- mh04ft97*lam5 - mh97h04ft97*lam6- mh97ft04*lam7- mh04ft04*lam8
- mh97h04ft04*lam9-mfertkgac97*lam10- mfertkgac04*lam11;
*restrict b0=0.79; 
theta = lam0 + lam1*hyb97 + lam2*hyb04 + lam3*h9704 + lam4*hyb97*fertkgac97 + lam5*hyb04*fertkgac97 + lam6*hyb97*hyb04*fertkgac97 
+ lam7*hyb97*fertkgac04	+ lam8*hyb04*fertkgac04 + lam9*hyb97*hyb04*fertkgac04 + lam10*fertkgac97 + lam11*fertkgac04 ; 
retb=b0+phi*theta; 
aveyld=aveyld; 
join904=join904;
leav904=leav904;
stay904=stay904;
nonh904=nonh904; 
switch=switch;
dhigh=dhigh;
dmed=dmed;
dlow=dlow;
fertskm04=fertskm04; 
cred97=cred97;
cred04=cred04;
fertskm97=fertskm97; 
dmot97=dmot97;
dmat97=dmat97; 
dext97=dext97; 
dmot04=dmot04;
dmat04=dmat04; 
dext04=dext04; 
hybnon=hybnon;
hyball=hyball;
switch=switch;
fertzero=fertzero; 
laveyld=laveyld;
joinall=joinall; 
leavall=leavall; 
annxt=annxt;
annit=annit;
annpre=annpre; 
sfmcost04=sfmcost04; 
dprov1=dprov1; dprov3=dprov3;dprov4=dprov4;dprov5=dprov5;dprov6=dprov6; 
hhid=hhid; 
year=year; 
test phi=1; 
test b0,phi;
*test lam0, lam2, lam3, lam5, lam6,lam7,lam8,lam9; 

fit lyld97 lyld04 parms= afert lam0 lam1 lam2 lam3 lam4 lam5 lam6 lam7 lam8 lam9 lam10 lam11 
b0 1 phi -1/gmm vdata=gcovh outresid out=ores; run;

solve LYLD97C LYLD04C  theta retb ptheta/out=outgmm74;run;

data ores1; set ores;
eres97=exp(lyld97);
eres04=exp(lyld04);
proc means data=ores1; run;
proc means data=ores1; var eres97; where hyb97=0; run;
proc means data=ores1; var eres97; where hyb97=1; run;
proc means data=ores1; var eres04; where hyb04=0; run;
proc means data=ores1; var eres04; where hyb04=1; run;

data outgmm741; set outgmm74; 
sdcst=60;
YLDC=(0.5*EXP(LYLD97C)+0.5*EXP(LYLD04C))*1.18;
if yldc>3000 then yldc=3000; 
RET=EXP(RETb)-1; 
RETC=ret*yldc;
return=retc-sdcst; 
if return>0 then adopt=1; else adopt=0; 
if join904=1 or leav904=1 then sw904=1;
if ret<1.5;
if yldc<3000;  
proc means data=outgmm741; var ret sdcst return adopt theta retb retc yldc ret adopt hyb97 hyb04 hyball hybnon nonh904 switch dlow dhigh; run; ; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb97 hyb04 stay904 hyball; where stay904=1 ; run; ; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb04 leav904; where leav904=1; run; ; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb04 join904; where join904=1; run; ; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb04 join904; where sw904=1; run; ; 
proc chart data=outgmm741; hbar yldc ret retc ; where stay904=1; run;

data swall; set outgmm741; 
if stay904=1 then do; pthall=ptheta; thswall=theta; retswall=return*100;
retall=retb*100; retallc=retc; end ; *else thswall=. and retswall=.;
*if retallc>0; run;
data swnon; set outgmm741;  
if nonh904=1 then do; ptnon=ptheta; thswnon=theta; retswnon=return*100; 
retnon=retb*100; retnonc=retc;end; 
*if theta<0; 
data swtch; set outgmm741;  
if switch=1 then do; thswtch=theta; retswtch=return*100; 
retsw=retb*100; retswc=retc; end; 
run; 
data join; set outgmm741;  
if join904=1 then do; ptjoin=ptheta; thjoin=theta; retjoin=return*100; 
retjn=retb*100; retjnc=retc; end; 
run; 
data leav; set outgmm741;  
if leav904=1 then do;ptleav=ptheta;  thleav=theta; retleav=return*100; 
retlv=retb*100; retlvc=retc;end; 
*if retlvc<20;
run; 

data swant; merge swall swnon join leav ;*swnonl ; 
run;

proc means data=swant; *var sfmch thswall thswnon  retswall retswnon retswtch retlow retmed rethig hyb97 
hyb04 hyball hybnon
retall retallm retnonl  retsw retjn retlv
retallc retnonc retjnc retlvc retallcm  retnoncl; run; 
title ' '; 


data hybm; set swant; *nonl for sample with outliers, nonll without; 
retallm=retall;
retallcm=retallc;
keep retallm retallcm;
run;

proc chart data=hybm; hbar retallcm; run;

data hybmjl; set swant; *nonl for sample with outliers, nonll without; 
keep retjn retlv retjnc retlvc;
run;

data hybmsw; set swtch; *nonl for sample with outliers, nonll without; 
keep retsw retswc;
run;


data outmed; set outgmm741; 
keep hhid year yldc retc dprov1 dprov3 dprov4 dprov5 dprov6; 
run; 
