* switchers ; 
data pan1s; set pan1; 
if 10<yld<7500;
*if dlow=1;
*if ((hfn=1) or (hyb=1 and hfs=1));
if switch1=1; 
if seedac<35; 
if fertac<600; 
*if year=1997 or year=2004; 
run; 
proc model  data=pan1s;  *and (year=1997 or year=2004); 
yld = (1-hyb)*(exp(b0 + bdl*dlow + bdh*dhigh + bd00*d00 + bd04*d04 + bd07*d07 + bd10*d10
/*+ adpr1*dprov1 + adpr3*dprov3 + adpr4*dprov4 + adpr5*dprov5 + adpr6*dprov6*/
 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld)) 
+ hyb*(exp(hb0 + hbdl*dlow + hbdh*dhigh + hbd00*d00 + hbd04*d04 + hbd07*d07 + hbd10*d10
/*+ hadpr1*dprov1 + hadpr3*dprov3 + hadpr4*dprov4 + hadpr5*dprov5 + hadpr6*dprov6*/
 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac)  + hay*layld));

ynn = exp(b0 + bdl*dlow + bdh*dhigh + bd00*d00 + bd04*d04 + bd07*d07 + bd10*d10
/*+ adpr1*dprov1 + adpr3*dprov3 + adpr4*dprov4 + adpr5*dprov5 + adpr6*dprov6*/
 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
yhn = exp(hb0 + hbdl*dlow + hbdh*dhigh + hbd00*d00 + hbd04*d04 + hbd07*d07 + hbd10*d10 
/*+ hadpr1*dprov1 + hadpr3*dprov3 + hadpr4*dprov4 + hadpr5*dprov5 + hadpr6*dprov6*/
+ hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac) + hay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
dlow=dlow;
dhigh=dhigh; 
hhid=hhid; 
year=year; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=ress; run; 
solve ynn yhn /out=oyldps; run;
data oylds; set oyldps;
bhybpa=100*(log(yhn)-log(ynn));
retcs=yhn-ynn; 
if -500<retcs<600; 
proc means data=oylds; var yhn ynn retcs; run;
proc means data=oylds; var yhn ynn retcs; where hyb=1; run;
proc means data=oylds; var yhn ynn retcs; where hyb=0; run;
proc chart data=oylds; hbar retcs; run;

proc sort data=oylds; by hhid year; run;
proc sort data=pan1s; by hhid year; run;
data oylds1s; merge oylds pan1s; 
retc=retcs; 
keep retc hhid year; run;


* low zone; 
data pan1l; set pan1; 
if 10<yld<2000;
if dlow=1;
*if hyb=1 and hfs=1 then hybhfs=1; *else hybhfs=0; 
if ((hfn=1) or (hyb=1 and hfs=1));
*if year=1997 or year=2004; 
if seedac<35; 
if fertac<600; 
run; 

proc model  data=pan1l;  *and (year=1997 or year=2004); 
yld = hfn*(exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ /*+ adf*(1-dfert) + afrt*log(1-dfert+fertac)*/ + asd*log(seedac) + ay*layld)) 
+ hyb*hfs*(exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac)  + hay*layld));

ynn = exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*//* + adf*(1-dfert) + afrt*log(1-dfert+fertac)*/ + asd*log(seedac) + ay*layld); 
yhn = exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac) + hay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
dlow=dlow;
dhigh=dhigh; 
hhid=hhid; 
year=year; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=resl; run; 
solve ynn yhn /out=oyldpl; run;

data oyldl; set oyldpl;
bhybpa=100*(log(yhn)-log(ynn));
retcl=yhn-ynn; 
if -700<retcl<600; 
run;
proc means data=oyldl; var yhn ynn retcl; where year<2007; run;
proc means data=oyldl; var yhn ynn retcl; where year>2004; run;
proc chart data=oyldl; hbar retcl; *where year<2007;  run;

proc sort data=oyldl; by hhid year; run;
proc sort data=pan1l; by hhid year; run;

data oyldl1l; merge oyldl pan1l; 
retc=retcl; 
keep retc hhid year; run;
run;

/*data oyldlo; set oyldpl;
bhybpa=100*(log(yhn)-log(ynn));
retclo=yhn-ynn; 
if -700<retclo<600; 
run;
proc means data=oyldlo; var yhn ynn retclo; run;
proc chart data=oyldlo; hbar retclo; run;

data oyld04; set oyldl;
retcl04=yhn-ynn; 
if year<2007; 
if retcl04>-500; 
if retcl04>175 then adopt04=1; else adopt04=0; 
run;

data oyld10; set oyldl;
retcl10=yhn-ynn; 
if year>2004; 
if retcl10>-500; 
if retcl10>175 then adopt10=1; else adopt10=0; run;

data oyld0410; merge oyld04 oyld10; 
keep retcl04 retcl10 adopt04 adopt10; 
label retcl04="Hybrid Returns (kg/ac)";
run;

proc means data=oyld0410; run;

proc sgplot data=oyld0410; 
density retcl04/type=kernel legendlabel='1997-2004' lineattrs=(color=black);
density retcl10/type=kernel legendlabel='2007-2010' lineattrs=(color=black);
run; 

data oyldloo; merge oyldl oyldlo; 
label retcl="Hybrid Returns (kg/ac)";
run;
proc means data=oyldloo; var retcl retclo; run;
proc sgplot data=oyldloo; 
density retcl/type=kernel legendlabel='Without Outliers' lineattrs=(color=black);
density retclo/type=kernel legendlabel='With Outliers' lineattrs=(color=black);
run; 

*/



* med zone; 

* med, perm hyb use vs trans non-use; 
proc means data=pan1; var yld; where hfsn=1 and dmed=1; run;
proc means data=pan1; var yld; where hybp=1 and dmed=1; run;

data pan1m; set pan1; where 40<yld<7500 and dmed=1 
and ((hfsn=1) or hybp=1);
if seedac<35; 
if fertac<600; 
*and (year=1997 or year=2004);  
proc model  data=pan1m; 
yld = hfsn*(exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit) + hadf*(1-dfert) + hafrt*log(1-dfert+fertac)*/ + hasd*log(seedac)  + hay*layld))
+ hybp*(exp(fhb0  + fhbd00*d00 + fhbd04*d04 + fhbd07*d07 
+ fhbd10*d10 + fhacm*log(acresm) + fhatot*ltotac + fham*log(main) + fhadmilk*dmilk + fhainter*inter + fhadoub*doub + fhahhsz*hhsize
+ fhaxt*log(annxt)  + fhadf*(1-dfert) + fhafrt*log(1-dfert+fertac) + fhasd*log(seedac)  + fhay*layld)); ; 

yhn = exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)
+ hadf*(1-dfert) + hafrt*log(1-dfert+fertac)*/ + hasd*log(seedac) + hay*layld);
yhf = exp(fhb0  + fhbd00*d00 + fhbd04*d04 + fhbd07*d07 
+ fhbd10*d10 + fhacm*log(acresm) + fhatot*ltotac + fham*log(main) + fhadmilk*dmilk + fhainter*inter + fhadoub*doub + fhahhsz*hhsize
+ fhaxt*log(annxt) + hadf*(1-dfert) + fhafrt*log(1-dfert+fertac) + fhasd*log(seedac)  + fhay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
hyb=hyb; 
hhid=hhid; 
year=year; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=resm; run; 
solve yhf yhn /out=oyldpm; run;

data oyldm; set oyldpm;
bhybpa=100*(log(yhn)-log(yhf));
retcm=yhf-yhn; 
if -500<retcm<1500; 
proc means data=oyldm; var hfsn hybp yhn yhf retcm; run;
proc chart data=oyldm; hbar retcm; run;

proc sort data=oyldm; by hhid year; run;
proc sort data=pan1m; by hhid year; run;
data oyldm1m; merge oyldm pan1m; 
retc=retcm; 
keep retc hhid year; run;
run;


* high zone; 
proc means data=pan1; var hfs hfp hfn; where dhigh=1; run;

data pan1h; set pan1; where 100<yld and dhigh=1 
and ((hfs=1 and hyb=0) or hyball=1) and seedac<35 and fertac<600;* and (year=1997 or year=2004); 
proc model  data=pan1h; 
yld = hfs*(1-hyb)*(exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld)) 
+ hyball*(exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit)*/+ hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac)  + hay*layld));

ynn = exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
yhn = exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac) + hay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
dlow=dlow;
dhigh=dhigh; 
hhid=hhid; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=resh; run; 
solve ynn yhn /out=oyldph; run;
data oyldh; set oyldph;
bhybpa=100*(log(yhn)-log(ynn));
retch=yhn-ynn; 
if -300<retch<2500; 
proc means data=oyldh; var yhn ynn retch; run;
proc chart data=oyldh; hbar retch; run;

proc sort data=oyldh; by hhid year; run;
proc sort data=pan1h; by hhid year; run;
data oyldh1h; merge oyldh pan1h; 
retc=retch; 
keep retc hhid year; run;
run;

data oylmhs; merge oyldh oyldm oyldl oylds; 
label retch="Hybrid Returns (kg/ac)";
run;
proc means data=oylmhs; var retcl retcm retch retcs;  run;

proc sgplot data=oylmhs; 
xaxis min=-500 max=1500; 
density retch/type = kernel legendlabel='Permanent Adopters - High' lineattrs=(color=black);
density retcm/type = kernel legendlabel='Permanent Adopters - Medium' lineattrs=(color=black);
density retcl/type = kernel legendlabel='Permanent Non-Adopters - Low' lineattrs=(color=black);
density retcs/type = kernel legendlabel='Transitory' lineattrs=(color=black);
run;

* ave by year; 
proc sort data=oyldl; by hhid; run;
proc sort data=oyldm; by hhid; run;
proc sort data=oyldh; by hhid; run;
proc sort data=oylds; by hhid; run;

proc means mean data=oyldl noprint; var retcl ; by hhid;   output out=oyldla mean=mretcl; run;
proc means mean data=oyldm noprint; var retcm ; by hhid;   output out=oyldma mean=mretcm; run;
proc means mean data=oyldh noprint; var retch ; by hhid;   output out=oyldha mean=mretch; run;
proc means mean data=oylds noprint; var retcs ; by hhid;   output out=oyldsa mean=mretcs; run;

data oylmhsa; merge oyldha oyldma oyldla oyldsa; 
label mretch="Hybrid Returns (kg/ac)";
run;
proc means data=oylmhsa; var mretcl mretcm mretch mretcs;  run;

proc sgplot data=oylmhsa; 
xaxis min=-500 max=1500; 
density mretch/type = kernel legendlabel='Permanent Adopters - High' lineattrs=(color=black);
density mretcm/type = kernel legendlabel='Permanent Adopters - Medium' lineattrs=(color=black);
density mretcl/type = kernel legendlabel='Permanent Non-Adopters - Low' lineattrs=(color=black);
density mretcs/type = kernel legendlabel='Transitory' lineattrs=(color=black);
run;


* retc regression; 

data oyldlmhs; set oylds1s oyldl1l oyldm1m oyldh1h; run;
proc means data=oyldlmhs; var retc; run;

proc sort data=oyldlmhs; by hhid year; run;
proc sort data=pan1; by hhid year; run;

data oyldpan1; merge oyldlmhs pan1; by hhid year;
retcs=100*(retc-365)/360;
run;

proc corr data=oyldpan1; var fkm dmot dext  retcs retc dlow dhigh; run; 

proc model data=oyldpan1; 
retcs = a0  + afkm*(fkm) + admot*dmot+adext*dext
+ acrd*cred + adl*dlow + adh*dhigh + adp104*dprov1 + adp304*dprov3 + adp404*dprov4 + adp504*dprov5 + adp604*dprov6 ;
test afkm,admot,adext;
*test adp104,adp304,adp404,adp504,adp604;
*test afkm,admot,adext,acrd,adp104,adp304,adp404,adp504,adp604;
fit retcs/hccme=3; 
run; 

