* full sample with interactions;
/*proc means data=gmm91; var dlow dmed dhigh switch hyball hybnon nonh904 stay904 leav904 join904  lyld97 hyb97 hyb04 h9704 h97ft97 h04ft97 h97h04ft97 h97ft04 h04ft04 h97h04ft04 fertkgac97 fertkgac04;  run; 
proc means data=gmm91; 
*/

proc chart data=gmm91; hbar fertkgac97 fertkgac04; where dhiv=0; run;
data gmm91a; set gmm91; *where switch=1; *if fertkgac97<600;
*if 10<yld97<5000; 
*if 10<yld04<5000; 
if dhiv=0; 
if seedkgac97=. then seedkgac97=1; 
if seedkgac97<1 then seedkgac97=1; 
if seedkgac04<1 then seedkgac04=1; *if dlow=0; 
if seedkgac97>35 then seedkgac97=35;
if seedkgac04>35 then seedkgac04=35;

*if fertkgac97<600; 
*if fertkgac97>200 then fertkgac97=200;
*if fertkgac04>200 then fertkgac04=200;

if fertcstac97<30000; 

*fertkgac97=fertaiac97;
*fertkgac04=fertaiac04;
*if fertcstac97>10000 then fertcstac97=10000;
*if fertcstac04>10000 then fertcstac04=10000;
fertkgac97=fertcstac97;
fertkgac04=fertcstac04;

h97ft97=hyb97*fertkgac97;
h04ft97=hyb04*fertkgac97;
h97h04ft97=hyb97*hyb04*fertkgac97;
h97ft04=hyb97*fertkgac04;
h04ft04=hyb04*fertkgac04;
h97h04ft04=hyb97*hyb04*fertkgac04;

*hlcostac04=hhrsac04; 

*if dhiv=0; 

/*if fhrsac97>1200 then fhrsac97=1200;
if fhrsac04>1200 then fhrsac04=1200;
if hlcostac97>10000 then hlcostac97=10000;
if hlcostac04>10000 then hlcostac04=10000; 
if lpcostac97>5000 then lpcostac97=5000;
if lpcostac04>5000 then lpcostac04=5000; 
*/
proc means data=gmm91a; var hhrsac97 hhrsac04 fhrsac97 fhrsac04 hlcostac97 hlcostac04
lpcostac97 lpcostac04 main97 main04 acresm97 acresm04 seedkgac97 seedkgac04 dlow dhiv dfert97 dfert04 yld97 yld04 
dlow dmed dhigh switch hyball hybnon nonh904 stay904 leav904 join904  lyld97 lyld04 hyb97 hyb04 h9704 h97ft97 h04ft97
h97h04ft97 h97ft04 h04ft04 h97h04ft04 fertkgac97 fertkgac04 fertskm97 fertskm04;    
run; 

/*
proc chart data=gmm91a; hbar lpcostac97 lpcostac04 fertskm97 fertskm04 fertkgac97 fertkgac04; run;

proc chart data=gmm91a; hbar acresm97 acresm04 seedkgac97 seedkgac04 lyld97 lyld04 fertkgac97 fertkgac04
fhrsac97 fhrsac04 hhrsac97 hhrsac04; run;*/
proc means data=gmm91a; var hyb97 hyb04 h9704 h97ft97 h04ft97 h97h04ft97 h97ft04 h04ft04 h97h04ft04 fertkgac97 fertkgac04; 
output out=mvars mean = mhyb97 mhyb04 mh9704 mh97ft97 mh04ft97 
 mh97h04ft97 mh97ft04 mh04ft04 mh97h04ft04 mfertkgac97 mfertkgac04;run; 
data mvars1; set mvars; drop _type_; run;
proc means data=mvars1; run;

proc model data=gmm91a; 
endogenous lyld97 lyld04; 
lyld97 = (del97)  + gam1* hyb97 + gam2*hyb04 + gam3*h9704 + gam4*h97ft97
+ gam5*h04ft97 + gam6*h97h04ft97 + gam7*h97ft04 + gam8*h04ft04 
+ gam9*h97h04ft04 + gam10*fertkgac97 + gam11*fertkgac04 
+ aseed97*seedkgac97 + aflab97*fhrsac97 + ahlab97*hlcostac97 + alp97*lpcostac97 + ac97*log(acresm97) + m97*(main97)
+ aboy97*boy97 + agirl97*girl97 + aman97*man97 + aoman97*oman97 + awom97*wom97 + ahhs97*hhsize97
;*+ atot97*(totacres97) + admilk97*dmilk97 + adou97*dou97 + aint97*int97 + ay97*laveyld9;

lyld04 = (del04)  + gam12* hyb97 + gam22*hyb04 + gam32*h9704 + gam42*h97ft97 + gam52*h04ft97
+ gam62*h97h04ft97 + gam72*h97ft04 + gam82*h04ft04 + gam92*h97h04ft04
+ gam102*fertkgac97 + gam112*fertkgac04 + aseed04*seedkgac04
+ aflab04*fhrsac04 + ahlab04*hlcostac04+ alp04*lpcostac04+ ac04*log(acresm04) + m04*(main04)
+ aboy04*boy04+ agirl04*girl04+ aman04*man04+ aoman04*oman04+ awom04*wom04+ ahhs04*hhsize04
;*+ atot04*(totacres04) + admilk04*dmilk04 + adou04*dou04 + aint04*int04 + ay04*laveyld4;
fit lyld97 lyld04/sur outest=gparmh outv=gcovh; run;

data gparmhm; merge gparmh mvars1; run;

proc model data=gmm91a parmsdata=gparmhm; 
endogenous lyld97 lyld04 ;
parms del97 del04 afert lam0 lam1 lam2 lam3 lam4 lam5 lam6 lam7 lam8 lam9 lam10 lam11 phi b0 gam1 gam2 gam3 gam4 gam5 gam6 gam7 gam8 gam9 gam10 gam11
gam12 gam22 gam32 gam42 gam52 gam62 gam72 gam82 gam92 gam102 gam112
mhyb97 mhyb04 mh9704 mh97ft97 mh04ft97 
 mh97h04ft97 mh97ft04 mh04ft04 mh97h04ft04 mfertkgac97 mfertkgac04;

lyld97 = del97  + (lam1*(1+phi)+ b0 + phi*(lam0))* hyb97
+ lam2*hyb04 + (phi*lam2+(1+phi)*lam3)*h9704 + ((1+phi)*lam4 + phi*lam10)*h97ft97
+ lam5*h04ft97 + ((1+phi)*lam6 + phi*lam5)*h97h04ft97 + ((1+phi)*lam7 + phi*lam11)*h97ft04 + lam8*h04ft04 
+ ((1+phi)*lam9 + phi*lam8)*h97h04ft04 + (lam10+afert)*fertkgac97 + lam11*fertkgac04  + aseed97*seedkgac97
+ aflab97*fhrsac97 + ahlab97*hlcostac97 + alp97*lpcostac97 + ac97*log(acresm97) + m97*(main97)
+ aboy97*boy97 + agirl97*girl97 + aman97*man97 + aoman97*oman97 + awom97*wom97 + ahhs97*hhsize97
;*+ atot97*(totacres97) + admilk97*dmilk97 + adou97*dou97 + aint97*int97 + ay97*laveyld9;

lyld04 = del04 + lam1* hyb97 
+ (lam2*(1+phi)+b0 +phi*(lam0))*hyb04 
+ (phi*lam1+(1+phi)*lam3)*h9704 + lam4*h97ft97 + ((1+phi)*lam5 + phi*lam10)*h04ft97
+ ((1+phi)*lam6+phi*lam4)*h97h04ft97 + lam7*h97ft04 + ((1+phi)*lam8 + phi*lam11)*h04ft04 + ((1+phi)*lam9 + phi*lam7)*h97h04ft04
+ lam10*fertkgac97 + (lam11+afert)*fertkgac04  + aseed04*seedkgac04
+ aflab04*fhrsac04 + ahlab04*hlcostac04+ alp04*lpcostac04 + ac04*log(acresm04) + m04*(main04)
+ aboy04*boy04+ agirl04*girl04+ aman04*man04+ aoman04*oman04+ awom04*wom04+ ahhs04*hhsize04
;*+ atot04*(totacres04) + admilk04*dmilk04 + adou04*dou04 + aint04*int04 + ay04*laveyld4;

lyld97c = del97 + lam2*hyb04 + lam5*h04ft97 + lam8*h04ft04 + (lam10+afert)*fertkgac97 + lam11*fertkgac04  + aseed97*seedkgac97
+ aflab97*fhrsac97 + ahlab97*hlcostac97 + alp97*lpcostac97 + ac97*log(acresm97) + m97*(main97)
+ aboy97*boy97 + agirl97*girl97 + aman97*man97 + aoman97*oman97 + awom97*wom97 + ahhs97*hhsize97
;*+ atot97*(totacres97) + admilk97*dmilk97 + adou97*dou97 + aint97*int97 + ay97*laveyld9;

lyld04c = del04 + lam1* hyb97 + lam4*h97ft97 + lam7*h97ft04 + lam10*fertkgac97 + (lam11+afert)*fertkgac04  + aseed04*seedkgac04
+ aflab04*fhrsac04 + ahlab04*hlcostac04+ alp04*lpcostac04 + ac04*log(acresm04) + m04*(main04)
+ aboy04*boy04+ agirl04*girl04+ aman04*man04+ aoman04*oman04+ awom04*wom04+ ahhs04*hhsize04
;*+ atot04*(totacres04) + admilk04*dmilk04 + adou04*dou04 + aint04*int04 + ay04*laveyld4;

ptheta=phi*theta; 
restrict lam0=-mhyb97*lam1- mhyb04*lam2- mh9704*lam3- mh97ft97*lam4
- mh04ft97*lam5 - mh97h04ft97*lam6- mh97ft04*lam7- mh04ft04*lam8
- mh97h04ft04*lam9-mfertkgac97*lam10- mfertkgac04*lam11;
*restrict b0=0.79; 
theta = lam0 + lam1*hyb97 + lam2*hyb04 + lam3*h9704 + lam4*hyb97*fertkgac97 + lam5*hyb04*fertkgac97 + lam6*hyb97*hyb04*fertkgac97 
+ lam7*hyb97*fertkgac04	+ lam8*hyb04*fertkgac04 + lam9*hyb97*hyb04*fertkgac04 + lam10*fertkgac97 + lam11*fertkgac04 ; 
retb=b0+phi*theta; 
aveyld=aveyld; 
join904=join904;
leav904=leav904;
stay904=stay904;
nonh904=nonh904; 
switch=switch;
dhigh=dhigh;
dmed=dmed;
dlow=dlow;
fertskm04=fertskm04; 
cred97=cred97;
cred04=cred04;
fertskm97=fertskm97; 
dmot97=dmot97;
dtar97=dtar97;
dmat97=dmat97; 
dext97=dext97; 
dmot04=dmot04;
dtar04=dtar04;
dmat04=dmat04; 
dext04=dext04; 
meduc97=meduc97;
meduc04=meduc04;
educ04=educ04; 
hybnon=hybnon;
hyball=hyball;
switch=switch;
fertzero=fertzero; 
laveyld=laveyld;
joinall=joinall; 
leavall=leavall; 
annxt=annxt;
annit=annit;
annpre=annpre; 
dprov1=dprov1; dprov3=dprov3;dprov4=dprov4;dprov5=dprov5;dprov6=dprov6; 

hhid=hhid; 
test phi=1; 
test b0,phi;
test lam0, lam2, lam3, lam5, lam6,lam7,lam8,lam9; 

fit lyld97 lyld04 parms= afert lam0 lam1 lam2 lam3 lam4 lam5 lam6 lam7 lam8 lam9 lam10 lam11  
b0 1 phi -1/gmm iter=1000 vdata=gcovh outresid out=ores; run;

solve LYLD97C LYLD04C  theta retb ptheta/out=outgmm74;run;

data ores1; set ores;
eres97=exp(lyld97);
eres04=exp(lyld04);
proc means data=ores1; run;
proc means data=ores1; var eres97; where hyb97=0; run;
proc means data=ores1; var eres97; where hyb97=1; run;
proc means data=ores1; var eres04; where hyb04=0; run;
proc means data=ores1; var eres04; where hyb04=1; run;

data outgmm741; set outgmm74; 
sdcst=exp(3.32+0.28*0.5*(lyld04+lyld97) - 0.95*dlow + 0.15*dhigh)
	-exp(3+0.28*0.5*(lyld04+lyld97) - 0.95*dlow + 0.15*dhigh);
YLDC=(0.5*EXP(LYLD97C)+0.5*EXP(LYLD04C))*1.3; *set E(exp(ln e)) = 1.3; 
if yldc>4000 then yldc=4000;
*if retb>2 then retb=2;  
RET=EXP(RETb)-1; 
RETC=ret*yldc;
thetac=theta*yldc; 
return=retc-sdcst; 
if return>0 then adopt=1; else adopt=0; 
if join904=1 or leav904=1 then sw904=1;

proc means data=outgmm741; run; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb97 hyb04 hyball hybnon nonh904 switch dlow dhigh; where nonh904=1 ; run; ; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb97 hyb04 stay904 hyball; where stay904=1 ; run; ; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb04 leav904; where leav904=1; run; ; 
proc means data=outgmm741; var return adopt theta retb retc yldc ret adopt hyb04 join904; where join904=1; run; ; 
proc chart data=outgmm741; hbar yldc retb retc; run;

data outgmm742; set outgmm741; 
*if retc<3000; 
if dmot97=. then dmot97=dmot04; 
if dmat97=. then dmat97=dmot04; 
if dtar97=. then dtar97=dtar04; 
if dext97=. then dext97=dext04; 

fertskm=(fertskm97+fertskm04)/2; 
cred=(cred97+cred04)/2; 
dmot=(dmot97+dmot04)/2; 
dtar=(dtar97+dtar04)/2;
dmat=(dmat97+dmat04)/2;
dext=(dext97+dext04)/2;
educ=educ04; *(meduc97+meduc04)/2; 
if educ=0 then ded0=1; else ded0=0;
if 0<educ<8 then ded1=1; else ded1=0; 
if educ=8 then ded8=1; else ded8=0; 
if 12>educ>8 then ded11=1; else ded11=0; 
if educ=12 then ded12=1; else ded12=0;
if educ>12 then ded13=1; else ded13=0; 
*if educ ne .; 
theta=theta*100; 
retcs=100*(retc-625)/956; 
* for use with zone model;
data distdat; set outgmm742; keep dlow dhigh hhid fertskm dmot dmat dext cred ded0 ded1 ded8 ded11 ded12 ded13; run; 
proc CORR data=outgmm742; var educ04 ded0 ded1 ded8 ded11 ded12 ded13;* theta retc retcs FErtskm dmot dmat dext educ ; run; 
proc means data=outgmm742; var retc FErtskm dmot dmat dext educ CRED dext97 dext04 dmat97 dmat04;   run; 
proc chart data=outgmm742; hbar theta; where fertskm<70;run;
proc model data=outgmm742; where fertskm<70;
theta = a0  + afkm*(fertskm) /*+adtar*dtar*/ + admot*dmot+admat*dmat+adext*dext
+ acrd*cred /*+ adl*dlow + adh*dhigh*/ + adp104*dprov1 + adp304*dprov3 + adp404*dprov4 + adp504*dprov5 + adp604*dprov6
+ aed0*ded0 + AED1*DED1 + aed8*ded8 + aed11*ded11 + aed12*ded12; 
test afkm,admot,admat,adext;
test adp104,adp304,adp404,adp504,adp604;
*test afkm,admot,admat,adext,acrd,adp104,adp304,adp404,adp504,adp604,
aed8,aed12;
test aed0,aed1,aed8,aed12;
test adl,adh;
fit theta; 
run; 
proc model data=outgmm742; where fertskm<70;
thetac = a0  + afkm*(fertskm) /*+adtar*dtar*/ + admot*dmot+admat*dmat+adext*dext
+ acrd*cred + adl*dlow + adh*dhigh + adp104*dprov1 + adp304*dprov3 + adp404*dprov4 + adp504*dprov5 + adp604*dprov6
+ aed0*ded0 + AED1*DED1 + aed8*ded8 + aed11*ded11 + aed12*ded12; 
test afkm,admot,admat,adext;
test adp104,adp304,adp404,adp504,adp604;
*test afkm,admot,admat,adext,acrd,adp104,adp304,adp404,adp504,adp604,
aed8,aed12;
test aed0,aed1,aed8,aed12;
test adl,adh;
fit thetac; 
run; 
proc model data=outgmm742; where fertskm<70; 
retcs = a0  + afkm*(fertskm) /*+adtar*dtar*/ + admot*dmot+admat*dmat+adext*dext
+ acrd*cred + adl*dlow + adh*dhigh + adp104*dprov1 + adp304*dprov3 + adp404*dprov4 + adp504*dprov5 + adp604*dprov6
+ aed0*ded0 + AED1*DED1 + aed8*ded8 + aed11*ded11 + aed12*ded12; 
test afkm,admot,admat,adext;
test adp104,adp304,adp404,adp504,adp604;
*test afkm,admot,admat,adext,acrd,adp104,adp304,adp404,adp504,adp604,
aed8,aed12;
test aed0,aed1,aed8,aed12;
test adl, adh; 
fit retcs/hccme=3; 
run; 

proc model data=gmm91; where sfmcost04>0; 
sfmcost04 = exp(a0 + ah*hyb04 + ay*yld97 );
sfmc1 = exp(a0 + ah + ay*yld97 );
sfmc0= exp(a0 + ay*yld97 );
sfmch=sfmc1-sfmc0; 
fit sfmcost04;*/outpredict out=osfmc; 
run;
solve sfmc1 sfmc0 sfmch/ out=osfmch; run;

proc means data=osfmch; var sfmc1 sfmc0 sfmch; run;

data swall; set outgmm741; 
if stay904=1 then do; pthall=ptheta; thswall=theta; retswall=return*100;
retall=retb*100; retallc=retc; end ; *else thswall=. and retswall=.;
if retall<150; if theta>-.3; run;
data swnon; set outgmm741;  
if nonh904=1 then do; ptnon=ptheta; thswnon=theta; retswnon=return*100; 
retnon=retb*100; retnonc=retc;end; 
if retnon>50; 
*if retnonc<600; 
data swtch; set outgmm741;  
if switch=1 then do; thswtch=theta; retswtch=return*100; 
retsw=retb*100; retswc=retc; end; 
run; 
data join; set outgmm741;  
if join904=1 then do; ptjoin=ptheta; thjoin=theta; retjoin=return*100; 
retjn=retb*100; retjnc=retc; end; 
run; 
data leav; set outgmm741;  
if leav904=1 then do;ptleav=ptheta;  thleav=theta; retleav=return*100; 
retlv=retb*100; retlvc=retc;end; 
if theta>-.1; run; 
data swlow; set outgmm741;  
if dlow=1 then do; thlow=theta; retlow=return*100; end; 
run; 
data swmed; set outgmm741;  
if dmed=1 then do; thmed=theta; retmed=return*100; end; 
run; 
data swhig; set outgmm741;  
if dhigh=1 then do; thhig=theta; rethig=return*100; end; 
run; 

data swant; merge osfmch swall swnon swtch swlow swmed swhig join leav ;*swnonl ; 
label thswall ="Theta"; 
label retall="Relative Hybrid Returns (100 x log kg/ac)";
label retallc="Hybrid Returns (kg/ac)";
run;

proc means data=swant; var sfmch thswall thswnon thjoin thleav retswall retswnon retswtch retlow retmed rethig hyb97 hyb04 hyball hybnon
retall retnon  retsw retjn retlv
retallc retnonc retjnc retlvc; run; 
title ' '; 

proc sgplot data=swant; *where -1<ret<2;
xaxis min=-50 max=150; 
density retall/type=kernel scale=count legendlabel='Permanent Adopters' lineattrs=(color=black); 
density retnon/type=kernel scale=count   legendlabel='Permanent Non-Adopters' lineattrs=(color=black); 
*density retnonl/type=kernel scale=count   legendlabel='Permanent Non-Adopters - Low' lineattrs=(color=black); 
density retjn/type=kernel scale=count  legendlabel='Joiners' lineattrs=(color=black); 
density retlv/type=kernel scale=count   legendlabel='Leavers' lineattrs=(color=black); 
run; 
proc sgplot data=swant; *where -1<ret<2;
xaxis min=-50 max=150; 
density retall/type=kernel  legendlabel='Permanent Adopters' lineattrs=(color=black); 
density retnon/type=kernel    legendlabel='Permanent Non-Adopters' lineattrs=(color=black); 
*density retnonl/type=kernel scale=count   legendlabel='Permanent Non-Adopters - Low' lineattrs=(color=black); 
density retjn/type=kernel   legendlabel='Joiners' lineattrs=(color=black); 
density retlv/type=kernel    legendlabel='Leavers' lineattrs=(color=black); 
run; 

proc sgplot data=swant; where yldc<2000; 
xaxis min=-300 max=1500; 
density retallc/type=kernel scale=count legendlabel='Permanent Adopters' lineattrs=(color=black); 
density retnonc/type=kernel scale=count   legendlabel='Permanent Non-Adopters' lineattrs=(color=black); *where retnonc<600; 
*density retnonlc/type=kernel scale=count   legendlabel='Permanent Non-Adopters' lineattrs=(color=black); *where retnonlc<200; 
density retjnc/type=kernel scale=count  legendlabel='Joiners' lineattrs=(color=black); 
density retlvc/type=kernel scale=count   legendlabel='Leavers' lineattrs=(color=black); *where retlvc<100; *where retlvc<800; 
*density sfmch/type=kernel scale=count   legendlabel='Fertilizer & Seed Cost' lineattrs=(color=grey);
run; 

proc sgplot data=swant; *where yldc<2000; 
xaxis min=-500 max=2000; 
density retallc/type=kernel  legendlabel='Permanent Adopters' lineattrs=(color=black); 
density retnonc/type=kernel    legendlabel='Permanent Non-Adopters' lineattrs=(color=black); *where retnonc<600; 
*density retnonlc/type=kernel scale=count   legendlabel='Permanent Non-Adopters' lineattrs=(color=black); *where retnonlc<200; 
density retjnc/type=kernel  legendlabel='Joiners' lineattrs=(color=black); 
density retlvc/type=kernel    legendlabel='Leavers' lineattrs=(color=black); *where retlvc<100; *where retlvc<800; 
*density sfmch/type=kernel    legendlabel='Fertilizer & Seed Cost' lineattrs=(color=grey);
run; 

proc sgplot data=swant; 
xaxis min=-200 max=1000; 
density retallc/type=kernel  legendlabel='Permanent Adopters' lineattrs=(color=black); 
density retnonc/type=kernel    legendlabel='Permanent Non-Adopters' lineattrs=(color=black); 
*density retnonlc/type=kernel    legendlabel='Permanent Non-Adopters' lineattrs=(color=black); *where retnonlc<200; 
density retjnc/type=kernel   legendlabel='Joiners' lineattrs=(color=black); 
density retlvc/type=kernel    legendlabel='Leavers' lineattrs=(color=black); *where retlvc<100; 
*density sfmch/type=kernel    legendlabel='Fertilizer & Seed Cost' lineattrs=(color=grey);
run; 

proc sgplot data=swant; 
xaxis min=-.5 max=.75; 
density thswall/type=kernel  legendlabel='Permanent Adopters' lineattrs=(color=black); 
density thswnon/type=kernel    legendlabel='Permanent Non-Adopters' lineattrs=(color=black); 
density thjoin/type=kernel   legendlabel='Joiners' lineattrs=(color=black); 
density thleav/type=kernel    legendlabel='Leavers' lineattrs=(color=black); 
run; 

proc sgplot data=swant; 
xaxis min=-.5 max=.75; 
density thswall/type=kernel scale=count  legendlabel='Permanent Adopters' lineattrs=(color=black); 
density thswnon/type=kernel scale=count    legendlabel='Permanent Non-Adopters' lineattrs=(color=black); 
density thjoin/type=kernel scale=count   legendlabel='Joiners' lineattrs=(color=black); 
density thleav/type=kernel scale=count    legendlabel='Leavers' lineattrs=(color=black); 
run; 

