*import data;

* 1997 data; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenya_general_data_stata\climate.dta' out=climate dbms = stata replace;
      run;
*proc means data=climate; run; 
data climate1; set climate; keep vil annpre annxt annit annpet annppe annmaxxt annminit ; run;
/*PROC export  DATA=climate1 OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\climate1.xls' DBMS=XLS REPLACE;
	SHEET='climate1'; run;*/

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenya_general_data_stata\tampa_rain_96_07.dta' out=tampa_rain_96_07 dbms = stata replace;
      run;
*proc means data=tampa_rain_96_07; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\allhhid07.xls' out=allhhid07 dbms = XLS replace;
     sheet='allhhid07'; getnames=yes; run;
*proc means data=allhhid07; run; 
proc import datafile='\\psf\Home\Documents\Tegemeo\data\KHH97_data_stata\hhidfinl97.dta' out=hhidfinl97 dbms = stata replace;

*proc means data=hhidfinl97 ;run;

*proc import datafile='\\psf\Home\Documents\Tegemeo\data\KHH97_data_stata\allhhid97.dta' out=allhhid97 dbms = stata replace;

*proc means data=hhidfinl97 ;run;



proc import datafile='\\psf\Home\Documents\Tegemeo\data\K97_newvars_income_stata\cropinc97.dta' out=cropinc97 dbms = stata replace;

*proc means data=cropinc97 ;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_97_lookup_stata\maizekgs.dta' out=maizekgs97 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_97_lookup_stata\cropconv.dta' out=cropconv97 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\fertprc97.dta' out=fertprc97 dbms = stata replace;

proc means data=fertprc97; run;

*proc means data=cropconv97; run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\fertprice_dap97.dta' out=fertprice_dap97 dbms = stata replace;

*proc means data=fertprice_dap97; run;


*proc means data=cropconv97; run;


proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\hh97.dta' out=hh97 dbms = stata replace;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\hhi97.dta' out=hhi97 dbms = stata replace;
proc contents data=hhi97; run;
proc means data=hh97; var mthfin97; run;
proc chart data=hh97; hbar mthfin97; run;
proc contents data=hh97; run;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\labor97.dta' out=labor97 dbms = stata replace;

*proc means data=labor97; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\khh_97_lookup_stata\pricelp.dta' out=pricelp dbms = stata replace;
*proc means data=pricelp; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\khh_97_lookup_stata\adquiv.dta' out=adquiv dbms = stata replace;
*proc means data=adquiv; run; 
*proc print data=adquiv; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\demog97.dta' out=demog97 dbms = stata replace;

proc means data=demog97; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\field97.dta' out=field97 dbms = stata replace;

proc means data=field97;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\croplev97.dta' out=croplev97 dbms = stata replace;

*proc means data=croplev97;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh97_data_stata\lstprd97.dta' out=lstprd97 dbms = stata replace;

*proc means data=lstprd97;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\kenya_cm0_12_20_date.xls' out=cmod0 dbms = XLS replace;
     sheet='sheet1'; getnames=yes; run;

proc sort data=cmod0; by hhid; run;
proc sort data=allhhid07; by hhid; run;
data cmod0h; merge cmod0 allhhid07; by hhid; 
if 1<zone<5 then dlow=1; else dlow=0; 
if zone=6 then dhigh=1; else dhigh=0; 
if 17440<plt_date then pltime=3; *plt in nov;
if 17270<plt_date<17330 then pltime=2; *plt in april;
if 17220<plt_date<17271 then pltime=1; *plt in march;
keep vil pltime; 
run;
*proc means data=cmod0h;  run; 
proc sort data=cmod0h; by vil; run;
proc means mean data=cmod0h noprint; var pltime ; by vil; output out=cmods mean=pltime; run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenya_General_data_stata\tampa_rainfall_vil_year_month.dta' out=rainfall dbms = stata replace;
proc means data=rainfall; run; 
data rainmall; set rainfall; where year=1997 or year=2000 or year=2004 or year=2007; 
if month=2 or month=3 then feb_rain=rain; else feb_rain=0; 
if month=3 or month=4 then mar_rain=rain; else mar_rain=0; 
if month=10 or month=11 then oct_rain=rain; else oct_rain=0; 
run;
proc sort data=rainmall; by year vil;run;
proc means sum data=rainmall noprint; var feb_rain mar_rain oct_rain ; by year vil; output out=rainsum sum=sfeb_rain smar_rain soct_rain; run;
proc means data=rainsum; run; 
proc sort data=rainsum; by vil; run;
proc sort data=cmods; by vil; run;

data rainsall; merge rainsum cmods; by vil; 
if pltime=1 then pltrain=sfeb_rain;
if pltime=2 then pltrain=smar_rain;
if pltime=3 then pltrain=soct_rain;
*proc means data=rainsall; run; 

/*PROC export  DATA=rainsall OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\rainsall.xls' DBMS=XLS REPLACE;
	SHEET='rainsall'; run;
*/
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenya_General_data_stata\tampa_rain_96_07.dta' out=rain9607 dbms = stata replace;
*proc means data=rain9607; *var main97 main00 main04 main07; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenya_General_data_stata\hiv_aids_prevalence.dta' out=hivaids dbms = stata replace;

*proc contents data=hivaids; run; 
*proc contents data=rain9607; run; 

data rain9607m; set rain9607; 
keep main97 main00 main04 main07 vil; 
/*PROC export  DATA=rain9607m OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\rain9607m.xls' DBMS=XLS REPLACE;
	SHEET='rain9607m'; run;*/


* 1997; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\khh97_data_stata\fertprc97.dta' out=fertprc97;
      run;
proc means data=fertprc97; run;
proc sort data=fertprc97; by dist; 
proc sort data=allhhid07; by dist; run;
data fprcid97; merge allhhid07 fertprc97; by dist;
kgdap=kgdap50/50; 
if kgdap=. then kgdap=27.1;
kgmap=kgmap50/50;
if kgmap=. then kgmap=19.76;
kgtsp=kgtsp50/50; 
if kgtsp=. then kgtsp=19.5;
kgssp=29;
kgnpk1=kg502020/50;
if kgnpk1=. then kgnpk1=22.1;
kgnpk2=kg502323/50;
if kgnpk2=. then kgnpk2=23.1;
kgnpk3=kg50255/50;
if kgnpk3=. then kgnpk3=22.1;
kgcan=kgcan50/50;
if kgcan=. then kgcan=20.1; 
kgasn=20.7;
kgurea=23.2;
keep kgdap kgmap kgtsp kgssp kgnpk1 kgnpk2 kgnpk3 kgcan 
kgasn kgurea hhid; 
proc means data=fprcid97; run; 


proc sort data=field97; by hhid field;
proc sort data=croplev97; by hhid field; run;
proc sort data=croplev97; by hhid; run;

data milk97; set lstprd97; 
if year=96 and liveprod=1;
vmilk97=avgprod*6*price; 
if vmilk97=. then vmilk97=0; * value for 6 months;
proc means data=milk97; run; 

data lstrev970; set lstprd97; 
if year=96 and liveprod>1;
vliv970=avgprod*6*price; 
if vliv97=. then vliv97=0; 
proc means data=lstrev970 noprint; var vliv970; by hhid; output out=lstrev97 sum=vliv97; run; 
proc means data=lstrev97; run;

data yld970; set croplev97 ; * maize production;
if year=1; 
if crop=1 then harvkg=qprod; * in fact there are no obs with crop=2; 
*if crop>2 and crop<7 then harvkg=qprod;
if crop=2 then harvkg=qprod*.85;
if harvest=1;
*if sdtype=. then sdtype=0; 
if sdtype=1 then hy97=1; else hy97=0;
IF CROP<3 THEN DMAIZE=1; ELSE DMAIZE=0; 
if unit=1 then mzpr = price/90;
if unit =2 then mzpr = price; 
run;
proc means data=yld970;  run;

proc sort data=yld970; by hhid;
proc sort data=allhhid07; by hhid; 
data mzprice97; merge yld970 allhhid07; by hhid; 
if dmaize=1; run;
proc means data=mzprice97; run; 
proc sort data=mzprice97; by dist; run; 
proc means mean data=mzprice97 noprint; var mzpr; by dist; output out=mzpr_dist97 mean=mmzpr97; run;
proc means data=mzpr_dist97; run; 
data distdat; set allhhid07; 
keep hhid dist; 
proc sort data=mzpr_dist97; by dist; 
proc sort data=distdat; by dist; 
data mzprdat97; merge distdat mzpr_dist97; by dist; 
proc means data=mzprdat97; run;  
proc sort data=mzprdat97; by hhid; run; 


data field97a; set field97;
if watersrc=1 then irrig=0; else irrig=1; 
IF YEAR=1; 
if harvest=1; 
if fertkg=. then fertkg=0;
if fertkgb=. then fertkgb=0;
if fertype =1 or fertype=2 or fertype=8 then fertkga=fertkg; else fertkga=0; 
if fertype=1 then dapkga=fertkg; else dapkga=0; 
if fertype=2 then mapkga=fertkg; else mapkga=0;
if fertype=3 then tspkga=fertkg; else tspkga=0;
if fertype=4 then sspkga=fertkg; else sspkga=0;
if fertype=5 then npk1kga=fertkg; else npk1kga=0;
if fertype=6 then npk2kga=fertkg; else npk2kga=0;
if fertype=7 then npk3kga=fertkg; else npk3kga=0;
if fertype=8 then cankga=fertkg; else cankga=0;
if fertype=9 then asnkga=fertkg; else asnkga=0;
if fertype=10 then ureakga=fertkg; else ureakga=0;
if fertype=11 then sakga=fertkg; else sakga=0;
if fertype<=12 then fertalla=fertkg; else fertalla=0; 
if frtypeb=1 then dapkgb=fertkg; else dapkgb=0; 
if frtypeb=2 then mapkgb=fertkg; else mapkgb=0;
if frtypeb=3 then tspkgb=fertkg; else tspkgb=0;
if frtypeb=4 then sspkgb=fertkg; else sspkgb=0;
if frtypeb=5 then npk1kgb=fertkg; else npk1kgb=0;
if frtypeb=6 then npk2kgb=fertkg; else npk2kgb=0;
if frtypeb=7 then npk3kgb=fertkg; else npk3kgb=0;
if frtypeb=8 then cankgb=fertkg; else cankgb=0;
if frtypeb=9 then asnkgb=fertkg; else asnkgb=0;
if frtypeb=10 then ureakgb=fertkg; else ureakgb=0;
if frtypeb=11 then sakgb=fertkg; else sakgb=0;
if frtypeb =1 or frtypeb=2 or frtypeb=8 then fertkgbb=fertkgb; else fertkgbb=0;  
if frtypeb<=12 then fertallb=fertkg; else fertallb=0; 
allfert=sum(of dapkga mapkga tspkga sspkga npk1kga npk2kga
npk3kga cankga asnkga ureakga 
dapkgb mapkgb tspkgb sspkgb npk1kgb npk2kgb
npk3kgb cankgb asnkgb ureakgb );
run;
proc means data=field97a; run;
data field970; set field97a ;
fertkg=fertkga+fertkgbb; 
dapkg97=sum(of dapkga dapkgb);
mapkg97=mapkga+mapkgb;
tspkg97=tspkga+tspkgb;
sspkg97=sspkga+sspkgb;
npk1kg97=npk1kga+npk1kgb;
npk2kg97=npk2kga+npk2kgb;
npk3kg97=npk3kga+npk3kgb;
cankg97=cankga+cankgb;
asnkg97=asnkga+asnkgb;
ureakg97=ureakga+ureakgb;
sakg97=sakga+sakgb;
fertai97=dapkg97*.38+cankg97*.27+mapkg97*.63+tspkg97*.45+sspkg97*.35+(npk1kg97+npk2kg97+npk3kg97)*.4+cankg97*.27+asnkg97*.3+ureakg97*.46;
fertall=fertalla+fertallb; 
PROC MEANS DATA=FIELD970; RUN; 

data labor970; set labor97;
ffa=ff*.9;
fca=fc*.775;
if fhrs>0 then famhrs=fhrs*days*sum(of fm ff fc); 
if fhrs=0 and avhrs>0 then famhrs=avhrs*days*sum(of fm ff fc); 
if fhrs=0 and avhrs=0 then famhrs=4.6*days*sum(of fm ff fc); 
if hhrs>0 then hrhrs=hhrs*days*sum(of hm hf); else hhrs=0; 
*if hhrs=0 and avhrs>0 then hrhrs=avhrs*days*sum(of hm hf); 
*if hhrs=0 and avhrs=0 then hrhrs=5.1*days*sum(of hm hf); 

proc means data=labor970; run;

proc sort data=labor970; by hhid; run; * labor; 
proc means sum mean data=labor970 noprint; var hrhrs famhrs ; by hhid ;  output out=slabor97 sum=hrhrs97 famhrs97; run;
*proc means data=slabor97; run;

data demog970; set demog97; * demog; 
if sex=1 and age=3 then dboy=1; else dboy=0; 
if sex=2 and age=3 then dgirl=1; else dgirl=0; 
if sex=1 and age=1 then dman=1; else dman=0; 
if sex=1 and age=2 then doman=1; else doman=0; 
if sex=2 and age<3 then dwom=1; else dwom=0; 

proc means max data=demog970 noprint;  var educ; by hhid;
output out=maxed97 max=meduc97; run; 
proc means data=maxed97; run;
proc means data=demog970 noprint sum n ; var dboy dgirl dman doman dwom; output out=hhdemog97 sum = boy97 girl97 man97 oman97 wom97 n=hhsize97; by hhid; run;
*proc means data=hhdemog97; run; 

proc sort data=yld970; by hhid field; run; * aggregate production to field level;
proc means sum mean data=yld970 noprint; var harvkg hy97 DMAIZE; by hhid field; *where dmaize=1;  output out=farmprod970 sum=sqprod shy97 SDMAIZE; run;
proc means data=farmprod970; run;

proc means data=yld970; run;
proc means sum data=yld970 noprint; var SEEDKG ; by hhid field;  output out=seed970 sum=seedkg97 ; where dmaize=1 and sdtype>0; run; *maize seed; 
proc means data=seed970 ; run; 

proc sort data=farmprod970; by hhid field;
proc sort data=field970; by hhid field;
data farmprod97; merge field970 farmprod970; by hhid field;

proc means data=farmprod97; run;

DATA MZ97; SET FARMPROD97; WHERE sdmaize>0; RUN; * calculate maize production by household; 
PROC MEANS DATA=MZ97; RUN; 

proc means sum mean data=MZ97 noprint; var sqprod shy97 acres fertkg fertai97 dapkg97 mapkg97 tspkg97 sspkg97 npk1kg97 npk2kg97 npk3kg97
cankg97 asnkg97 ureakg97 fertall allfert; by hhid;  output out=mzprod97 
sum=mzprod97 sshy97 acresm97
 fertkg97 sfertai97 sdapkg97 smapkg97 stspkg97 ssspkg97 snpk1kg97 snpk2kg97
snpk3kg97 scankg97 sasnkg97 sureakg97 fertall97  allfert97; run;
proc means data=mzprod97; run; 

/*data mzprod97; set mzprod970; * code to check on mixed nonh & hyb use, shows small proportion of hyb users also have a field without;
uhyb97=sshy97/_freq_; 
keep hhid mzprod97 _freq_ sshy97 uhyb97; 
proc means data=mzprod97; *where mzprod97>0; run; 
proc chart data=mzprod97; hbar sshy97 uhyb97; where sshy97>0; run; 
*/
proc sort data=mz97; by hhid lptype; run;
proc means sum data=MZ97 noprint; var  lpcost; by hhid;  output out=lprep97 sum= lpcost97 ; where lptype>1; run;
proc means data=lprep97; run; 

* create vars for intercropping index; 
proc sort data=yld970; by hhid field;
proc sort data=mz97; by hhid field; run; 

data idyld97; merge yld970 mz97; by  hhid field ; run;
proc means data=idyld97; run; 
proc means sum data=idyld97 noprint; var crop; by hhid field;  output out=ncrp970 n=ncrp97; where sdmaize=1; run;
proc means data=ncrp970; run; 
proc means mean data=ncrp970 noprint; var ncrp97; by hhid; output out=ncrpf97 mean=ncrpf97; run; 
proc means data=ncrpf97; run; 

proc sort data=field970; by hhid; * total acres in all crops; 
proc means data=field970 sum noprint; var acres; by hhid; output out=totac97 sum=totacres97; run;
proc means data=totac97; run;

data hh97a; set hh97;
wage97=wagerate;
fertskm97=fertskm;
dmot97=dmtroad;
dtar97=dtmroad;
dmat97=dm3stop;
dext97=dextn;
if credrecv=3 then credrecv=.;
if credrecv=1 then cred97=1; else cred97=0; 
keep hhid wage97 mthfin97 fertskm97 cred97 cragget credrecv dmot97 dtar97 dext97 dmat97;
proc means data=hh97a; var wage97 sellmaiz; run;
proc chart data=hh97a; hbar wage97; run;
proc means data=hh97a; run;
proc sort data=hh97a; by hhid; run;
proc contents data=hh97; run;
proc sort data=mzprod97; by hhid; run;
proc sort data=fprcid97; by hhid; run;
proc sort data=maxed97; by hhid; run;
data hh97pur; set hh97;
if sellmaiz=1 then dmzpur97=1; else dmzpur97=0; 
keep hhid dmzpur97 ;


data yld97out; merge hh97pur maxed97 mzprod97 ncrpf97 hh97a totac97 lstrev97 milk97 slabor97 seed970 hhdemog97 lprep97 mzprdat97 fprcid97; by hhid;
if sshy97>0 then hyb97=1; else hyb97=0; 
yld97=mzprod97/acresm97; 
*fertac97=sfert/acresm97; 
if acresm97>0; 
IF 0<YLD97<10000; 
fertkgac97=fertkg97/acresm97; 
fertaiac97=sfertai97/acresm97;
if fertaiac97=. then fertaiac97=0; 
dapkgac97=sdapkg97/acresm97; 
mapkgac97=smapkg97/acresm97; 
tspkgac97=stspkg97/acresm97; 
sspkgac97=ssspkg97/acresm97; 
npk1kgac97=snpk1kg97/acresm97; 
npk2kgac97=snpk2kg97/acresm97; 
npk3kgac97=snpk3kg97/acresm97; 
cankgac97=scankg97/acresm97; 
asnkgac97=sasnkg97/acresm97; 
ureakgac97=sureakg97/acresm97; 
if dapkgac97=. then dapkgac97=0; 
if mapkgac97=. then mapkgac97=0;
if tspkgac97=. then tspkgac97=0;
if sspkgac97=. then sspkgac97=0;
if npk1kgac97=. then npk1kgac97=0;
if npk2kgac97=. then npk2kgac97=0;
if npk3kgac97=. then npk3kgac97=0;
if cankgac97=. then cankgac97=0;
if asnkgac97=. then asnkgac97=0;
if ureakgac97=. then ureakgac97=0;
fertcstac97=kgdap*dapkgac97+kgmap*mapkgac97+kgtsp*tspkgac97
+kgssp*sspkgac97+kgnpk1*npk1kgac97+kgnpk2*npk2kgac97+kgnpk3*npk3kgac97
+kgcan*cankgac97+kgasn*asnkgac97+kgurea*ureakgac97;
fertallac97=fertall97/acresm97;
if lpcost97 ne . then lpcostac97=lpcost97/acresm97; else lpcostac97=0; 
hhrsac97=hrhrs97/acresm97; 
if hhrsac97=. then hhrsac97=0; 
if wage97 ne . then hlcostac97=0.5*wage97*hhrsac97; else hlcostac97=0.5*58*hhrsac97; 
fhrsac97=famhrs97/acresm97; 
if fhrsac97=. then fhrsac97=0; 
seedkgac97=seedkg97/acresm97; 
if seedkgac97=. then seedkgac97=0; 
div97=ncrpf97; 
if hhid=lag(hhid) then delete; 
allfertac97=allfert97/acresm97; 

proc means data=yld97out; var dmzpur97 kgdap dapkgac97 kgmap mapkgac97 kgtsp tspkgac97
 kgssp sspkgac97 kgnpk1 npk1kgac97 kgnpk2 npk2kgac97 kgnpk3 npk3kgac97
 kgcan cankgac97 kgasn asnkgac97 kgurea ureakgac97; run;
proc means data=yld97out; var seedkgac97 allfertac97 fertall97 wage97 hlcostac97 meduc97 fertcstac97 fertaiac97 fertskm97 dmot97 dext97 dmat97 mmzpr97 sshy97 yld97 lpcostac97 seedkgac97 acresm97 totacres97 div97 HYB97 cred97 fertkgac97 dapkgac97 mapkgac97 cankgac97 fertallac97 hhrsac97 fhrsac97; *WHERE ACRESM97<10; run;
proc corr data=yld97out; var fertcstac97 fertkgac97 fertaiac97; run;
proc chart data=yld97out; hbar fertcstac97 yld97 vmilk97 div97; run;
proc chart data=yld97out; hbar  fertkgac97; run;
proc plot data=yld97out; plot fertcstac97*fertkgac97; where fertkgac97<600; run;
PROC export  DATA=yld97out OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\teg_yld97_4-8-18.xls' DBMS=XLS REPLACE;
	SHEET='yld97'; run;


* 2000 data; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\cropinc00.dta' out=cropinc00 dbms = stata replace;

*proc means data=cropinc00 ;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\fert00.dta' out=fert00 dbms = stata replace;

*proc means data=fert00 ;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_00_lookup_stata\maizekgs.dta' out=maizekgs00 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_00_lookup_stata\cropconv.dta' out=cropconv00 dbms = stata replace;

*proc means data=cropconv00; run;


proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\hh00.dta' out=hh00 dbms = stata replace;
proc means data=hh00; var nfermz slope; run;
proc contents data=hh00; run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\purch00.dta' out=purch00 dbms = stata replace;
proc means data=purch00; run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\field00.dta' out=field00 dbms = stata replace;

*proc means data=field00;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\croplev00.dta' out=croplev00 dbms = stata replace;

*proc means data=croplev00;run;


PROC import  DATAfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\allhhid07.dta' out=allhhid07 DBMS=stata REPLACE; run;


proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\field00.dta' out=field00 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\croplev00.dta' out=croplev00 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\fert00.dta' out=fert00 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Kenyahh00_data_stata\lstprd00.dta' out=lstprd00 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K00_newvars_demog_stata\ae_hhsize00.dta' out=hhsize00 dbms = stata replace;
*proc means data=hhsize00; run;

*proc means data=lstprd00 ;run;


proc sort data=field00; by hhid field;
proc sort data=croplev00; by hhid field; run;
proc sort data=fert00; by hhid field; run; 
proc sort data=lstprd00; by hhid; run;

data milk00; set lstprd00; 
if liveprod=1;
vmilk00=avgprod*6*price; 
if vmilk00=. then vmilk00=0; * value for 6 months;
proc means data=milk00; run; 

data lstrev000; set lstprd00; 
if liveprod>1 then vliv000=avgprod*6*price; 
if vliv000=. then vliv000=0;
proc means data=lstrev000 noprint; var vliv000; output out=lstrev00 sum=vliv00; by hhid;  run; 
proc means data=lstrev00; run; 


data yld000; set croplev00 ; * maize production;
if crop=1 then harvkg=kg_harv;
if crop=2 then harvkg=kg_harv*.85;
*if crop<3;
if SEASON=1;
if sdtype=1 then hy00=1; else hy00=0;
IF CROP<3 THEN DMAIZE=1; ELSE DMAIZE=0; 
run;

data field000; set field00;
if watersrc=1 then irrig=0; else irrig=1; 
if season=1; 
run;
proc means data=field000; run;

data fert000; set fert00;
if season=1;
if fertotal=. then fertotal=0;  
if ferttype =1 or ferttype=2 or ferttype=8 or ferttype=17 then fertot=fertotal; 
if 0<ferttype<12 or 14<ferttype<18 or 19<ferttype<25 then fertall=fertotal; else fertall=0;  
keep hhid field fertot fertall;
run;
proc means data=fert000; run;

proc sort data=yld000; by hhid field; run; * aggregate production;

proc means sum mean data=yld000 noprint; var harvkg hy00 DMAIZE; by hhid field;  output out=farmprod000 sum=sqprod shy00 SDMAIZE; run;
proc means data=farmprod000; run;

proc means sum mean data=yld000 noprint; var sqt ; by hhid field; where dmaize=1;  output out=sd00 sum= ssqt ; run;
proc means data=sd00; run;

proc sort data=farmprod000; by hhid field;
proc sort data=field000; by hhid field;
proc sort data=fert000; by hhid field; run; 
data farmprod00; merge field000 fert000 farmprod000 sd00; by hhid field;
proc means data=farmprod00; run;

DATA MZ00; SET FARMPROD00; WHERE SDMAIZE>0; RUN; 

data idyld00; merge yld000 mz00; by  hhid field ; run;

proc means sum data=idyld00 noprint; var crop; by hhid field;  output out=ncrp000 n=ncrp00; where sdmaize>0; run;
proc means data=ncrp000; run; 
proc means mean data=ncrp000 noprint; var ncrp00; by hhid; output out=ncrpf00 mean=ncrpf00; run; 
proc means data=ncrpf00; run; 

proc means sum data=MZ00 noprint; var sqprod ssqt shy00 acres fertot fertall lpcost; by hhid;  output out=mzprod00 sum=mzprod00 ssqt00 sshy00 acresm00 fertkg00 fertall00 lpcost00; run;
proc means data=mzprod00; run; 

DATA MZAC00; MERGE FIELD00 CROPLEV00; BY HHID FIELD; 
proc means sum data=MZAC00 noprint; var acres; by hhid field; output out=acresm00 sum=acm00; where SEASON=1 AND CROP<3; run;
proc means sum data=MZAC00 noprint; var acres ; by hhid field; output out=acresn00 sum=acn00 ; where SEASON=1 AND CROP>2; run;
data acresmn00; merge acresm00 acresn00; by hhid field; run;
proc means sum data=acresmn00 noprint; var acm00 acn00; output out = sacresmn00 sum=acm00 acn00; by hhid; run; 
proc means data=sacresmn00; run; 

proc sort data=field00; by hhid; * total acres in all crops; 
proc means data=field00 sum noprint; var acres; by hhid; output out=totac00 sum=totacres00; run;
proc means data=totac00; run;

data hh00a; set hh00;
nfermz00=nfermz;
slope00=slope; 
fertskm00=fertskm;
dmot00=dmtroad;
dmat00=dm3stop;
dext00=dextn;

if credwhy=4 and credrecv=1 then cred00=1; else cred00=0; 
keep hhid mthfin00 fertskm00 cred00 credwhy credrecv dmot00 dmat00 dext00;

data purch000; set purch00; 
if purch=1 then dmzpur00=1; 
if dmzpur00 ne .; 
keep hhid dmzpur00; 
run;
proc means data=purch000; var dmzpur00 hhid; run; 

proc sort data=purch000; by hhid; run;
proc sort data=hh00a; by hhid; run;
proc sort data=mzprod00; by hhid; run;
proc sort data=hhsize00; by hhid;  run;
data yld00; merge purch000 mzprod00 hh00a totac00 lstrev00 milk00 ncrpf00 hhsize00; by hhid;
if dmzpur00=. then dmzpur00=0; 
if sshy00>0 then hyb00=1; else hyb00=0; 
yld00=mzprod00/acresm00; 
*fertac00=sfert/acresm00; 
seedkgac00=ssqt00/acresm00; 
if acresm00>0; 
IF 0<YLD00<10000; 
fertkgac00=fertkg00/acresm00; 
if fertkgac00=. then fertkgac00=0; 
allfertac00=fertall00/acresm00; 
if allfertac00=. then fertallac00=0; 
lpcostac00=lpcost00/acresm00; 
div00=ncrpf00; 
proc means data=yld00; var dmzpur00 dmot00 dmat00 dext00 hhsize00 fertkgac00 allfertac00 div00 yld00 acresm00 totacres00 HYB00 cred00 seedkgac00; *WHERE ACRESM00<10; run;
run;
proc chart data=yld00; hbar yld00; run;

PROC export  DATA=yld00 OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\teg_yld00_1-11-18.xls' DBMS=XLS REPLACE;
	SHEET='yld00'; run;

* 2004 data;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\purch04.dta' out=purch04 dbms = stata replace;
*proc means data=purch04; run;
data purch040; set purch04; 
if purch=1 then dmzpur04=1; 
if dmzpur04 ne .; 
keep hhid dmzpur04; 
run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\hh04.dta' out=hh04 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_lookup_stata\pricefert.dta' out=pricefert04 dbms = stata replace;
proc means data=pricefert04; run;

*proc contents data=hh04; run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\tfert04.dta' out=tfert04 dbms = stata replace;
*proc means data=tfert04;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\field04.dta' out=field04 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\croplev04.dta' out=croplev04 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\fert04.dta' out=fert04 dbms = stata replace;
*proc means data=fert04;run;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\input04.dta' out=input04 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\labour04.dta' out=labor04 dbms = stata replace;

*proc means data=labor04;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\maizeseed04.dta' out=mseed04 dbms = stata replace;

*proc means data=mseed04;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\demoga04.dta' out=demoga04 dbms = stata replace;

*proc means data=demoga04;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\demogc04.dta' out=demogc04 dbms = stata replace;

*proc means data=demogc04;run;


proc import datafile='\\psf\Home\Documents\Tegemeo\data\Khh_2004_data_stata\lstprd04.dta' out=lstprd04 dbms = stata replace;

*proc means data=lstprd04 ;run;

*PROC CONTENTS DATA=FIELD04; RUN; 

proc sort data=field04; by hhid field;
proc sort data=croplev04; by hhid field; run;
proc sort data=; by hhid field; run; 
proc sort data=lstprd04; by hhid; run; 

*proc means data=croplev04; run; 

data milk04; set lstprd04; 
if liveprod=1;
vmilk04=avgprod*6*price; 
if vmilk04=. then vmilk04=0; * value for 6 months;
*proc means data=milk04; run; 

data lstrev040; set lstprd04; 
if liveprod>1;
vliv040=avgprod*6*price; 
if vliv040=. then vliv040=0;
proc means data=lstrev040 noprint; var vliv040; output out=lstrev04 sum=vliv04; by hhid; run;
*proc means data=lstrev04; run;  

data mseed040; set mseed04; where season=1; 
if units=1 then do; seedkg=qty; mzspr=price; end;
if units=2 then do; seedkg=qty*2; mzspr=price/2; end;
if units=9 then do; seedkg=qty*2; mzspr=price/2; end;
if units=3 then do; seedkg=qty*5; mzspr = price/5; end;
if units=4 then do; seedkg=qty*10;mzspr = price/10; end;
if units=5 then do; seedkg=qty*25;mzspr = price/25; end;
proc means mean sum data=mseed040 sum noprint; 
var seedkg mzspr sdvar sdtype; 
output out=seed04 mean=mseedkg mzspr04 sdvar04 sdtype04 sum=seedkg04 smzspr ssdvar ssdtype; by hhid; run;
proc means data=seed04; run; 
proc sort data=labor04; by hhid field; run;* labor; 

data labor040; set labor04; where crop<3;
manhrs=lb06; if manhrs=. then manhrs=0; 
womhrs=lb08;*0.9*lb08; if womhrs=. then womhrs=0; * sure does not adjust;
chlhrs=lb10; *0.775*lb10; if chlhrs=. then chlhrs=0; 
fhrs=sum(of manhrs womhrs chlhrs); 
hrhrs=5.1*lb01*lb02;
hlabwg=lb01*lb02*lb03;  
hlabcost=sum(of hlabwg lb04);
if sizefild=1; 
proc means data=labor040; run;

proc sort data=labor040; by hhid field; run; 
proc means sum mean data=labor040 noprint; var fhrs hrhrs hlabcost ; by hhid field ;  output out=slabor04 sum=famhrs04 hrhrs04 hlcost04; run;
proc means data=slabor04; run;

data demoga040; set demoga04; * demog; 
if da02=1 and 15<age<40 then dman=1; else dman=0; 
if da02=1 and age>39 then doman=1; else doman=0; 
if da02=2 then dwom=1; else dwom=0; 

data maxed04; set demoga040; 
if da03=1;
educ04=da06; 
keep hhid educ04; 
proc means data=maxed04; run;

proc means data=demoga040 noprint sum n ; var  dman doman dwom; output out=hhdemoga04 sum = man04 oman04 wom04 n=nadults; by hhid; run;
*proc means data=hhdemoga04; run; 

data demogc040; set demogc04; * demog; 
cage=2004-dc01;
if dc02=1 and 5<cage<16 then dboy=1; else dboy=0; 
if dc02=2 and 5<cage<16 then dgirl=1; else dgirl=0; 

proc means data=demogc040 noprint sum n ; var  dboy dgirl ; output out=hhdemogc04 sum = boy04 girl04 n=nchild; by hhid; run;
*proc means data=hhdemogc04; run; 

data hhdemog04; merge hhdemoga04 hhdemogc04; by hhid; 
if boy04=. then boy04=0;
if girl04=. then girl04=0;
if man04=. then man04=0;
if oman04=. then oman04=0;
if wom04=. then wom04=0;
if nchild=. then nchild=0; 
hhsize04=sum(of nadults nchild); 
*proc means data=hhdemog04; run;

data yld040; set croplev04 ; * maize production;
if crop=1 then harvkg=kg_harv;
if crop=2 then harvkg=kg_harv*.85;
*if crop<3;
if harvest=1;* and crop<3;

if sdtype=1 then hy04=1; else hy04=0;
IF CROP<3 THEN DMAIZE=1; ELSE DMAIZE=0; 
if slunit=1 then mzpr = price/90;
if slunit=2 then mzpr = price;
if slunit=3 then mzpr = price/50;
if slunit=9 then mzpr = price; 
if 3<slunit<9 or slunit >9 then mzpr = .;  
run;
proc means data=yld040; run;
proc sort data=yld040; by hhid;
proc sort data=allhhid07; by hhid; 
data mzprice04; merge yld040 allhhid07; by hhid; 
if dmaize=1; run;
proc sort data=mzprice04; by dist; run; 
proc means mean data=mzprice04 noprint; var mzpr; by dist; output out=mzpr_dist04 mean=mmzpr04; run;
data distdat; set allhhid07; 
keep hhid dist; 
proc sort data=distdat; by dist; 
data mzprdat04; merge distdat mzpr_dist04; by dist; 
proc sort data=mzprdat04; by hhid; 

data field040; set field04;
if watersrc=1 then irrig=0; else irrig=1; 
if harvest=1;run;
proc means data=field040; run; 
/*
data pricefert040; set pricefert04; 
pferttype= ferttype;
pfertunit=fertunit;
drop ferttype; drop fertunit; 
run;
*/
*proc means data=pricefert040; run;
proc means data=fert04; run;
proc sort data=fert04; by hhid; run;
proc sort data=distdat; by hhid; run;
data fert04d; merge fert04 distdat; by hhid; run;
proc sort data=fert04d; by dist ferttype fertunit; run;
proc sort data=pricefert04; by dist ferttype fertunit; run;
data fert040; merge pricefert04 fert04d; by dist ferttype fertunit; 
if harvest=1;
if fertotal=. then fertotal=0;  
*keep hhid field fertotal;
if ferttype =1 or ferttype=2 or ferttype=8 /*or ferttype=17*/ then fertot=fertotal; else fertot=0;; 
if 0<ferttype<12 or 14<ferttype<18 or 19<ferttype<25 then allfert=fertotal; else allfert=0;  
if ferttype=1 then dapkg04=fertotal; else dapkg04=0; 
if ferttype=2 then mapkg04=fertotal; else mapkg04=0; 
if ferttype=3 then tspkg04=fertotal; else tspkg04=0; 
if ferttype=4 then sspkg04=fertotal; else sspkg04=0; 
if 4<ferttype<8 or ferttype=15 or ferttype=16 or 20<ferttype<25 then npkkg04=fertotal; else npkkg04=0; 
if ferttype=10 then ureakg04=fertotal; else ureakg04=0; 
if ferttype=11 then sakg04=fertotal; else sakg04=0; 
if ferttype=8 or ferttype=17 then cankg04=fertotal; else cankg04=0; 
if ferttype=. then delete;
if dapkg04=. then dapkg04=0;
if mapkg04=. then mapkg04=0;
if cankg04=. then cankg04=0;
fertai04=dapkg04*.38+cankg04*.27+mapkg04*.63+tspkg04*.45+sspkg04*.35+(npkkg04)*.4+cankg04*.27+ureakg04*.46;
if allfert=. then allfert=0; 
pfert04=pfert/kgconver; 
qfert=fertqty*kgconver;
convert=fertotal/fertqty; 
vfert04=pfert*fertqty;
run;

proc means data=fert040;  run;

proc chart data=fert040; hbar fertotal; where ferttype=1 and fertunit=2; run;
proc sort data=fert040; by ferttype; run;
proc chart data=fert040; hbar vfert04; where 0<vfert04<25000; run;

proc sort data=fert040; by hhid field; run;
proc means data=fert040 noprint; var fertot fertai04 dapkg04 
mapkg04 tspkg04 npkkg04 cankg04 ureakg04 allfert vfert04; by hhid field;
output out=fert04s sum=sfertot ffertai04 sdapkg04 smapkg04 stspkg04 snpkkg04 scankg04 sureakg04 sallfert svfert04; run; 
proc means data=fert04s; run;

proc sort data=yld040; by hhid field; run; * aggregate maize production;
proc means sum mean data=yld040 noprint; var harvkg sqt hy04 crop DMAIZE ; by hhid field;  where dmaize=1; output out=farmprod040 sum=sqprod ssqt shy04 scrop SDMAIZE; run;
*proc means data=farmprod040; run;

proc sort data=farmprod040; by hhid field;
proc sort data=field040; by hhid field;
proc sort data=fert04s; by hhid field; 
data farmprod04; merge field040 fert04s farmprod040; by hhid field;
*proc means data=farmprod04; run;

DATA MZ04; SET FARMPROD04; WHERE sqprod ne .; RUN; 

proc means sum data=mz04 noprint; 
var sqprod ssqt shy04 acres sfertot ffertai04 sdapkg04 smapkg04 stspkg04 snpkkg04 scankg04 sureakg04 sallfert svfert04; by hhid;  
output out=mzprod04 sum=mzprod04 ssqt04 sshy04 acresm04 fertkg04 
sfertai04 tdapkg04 tmapkg04 ttspkg04 tnpkkg04 tcankg04 tureakg04 allfert04 tvfert04; run;
*proc means data=mzprod04; run; 
proc sort data=mz04; by hhid landprep; run;
proc means sum data=mz04 noprint; var  lpcost; by hhid ;  output out=lprep04 sum=lpcost04; where landprep>1; run; 
proc means data=lprep04; run; 

* labor cost per ac; 
proc sort data=mz04; by hhid field; run;
proc sort data=slabor04; by hhid field; run;
data laborac04; merge mz04 slabor04; by hhid field;
fhrsac04=famhrs04/acres;
hhrsac04=hrhrs04/acres;
hlcostac04=hlcost04/acres;
if (fhrsac04 ne .) or (hlcostac04 ne .) or (hhrsac04 ne .);  
keep fhrsac04 hhrsac04 hlcostac04 hhid hlcost04; 
*if acres>0.01;
run; 
proc means data=laborac04; run;


* create vars for intercropping index; 
proc sort data=yld040; by hhid field; run;
proc sort data=mz04; by hhid field; run; 
data idyld04; merge yld040 mz04; by  hhid field ; run;
proc means sum data=idyld04 noprint; var crop; by hhid field;  output out=ncrp040 n=ncrp04;  run;
*proc means data=ncrp040; run;
proc sort data=ncrp040; by hhid; run; 
proc means mean data=ncrp040 noprint; var ncrp04; by hhid; output out=ncrpf04 mean=ncrpf04; run; 

proc sort data=field040; by hhid; * total acres in all crops; 
proc means data=field040 sum noprint; var acres; by hhid; output out=totac04 sum=totacres04; run;
*proc means data=totac04; run;

data hh04a; set hh04;
fertskm04=fertskm;
dmot04=dmtroad;
dtar04=dtmroad;
dext04=dextn;
dmat04=dm3stop;
if credrecv=1 then cred04=1; else cred04=0; 
keep hhid mthfin04 fertskm04 cred04 dmot04 dext04 dmat04 dtar04;

proc sort data=hh04a; by hhid; run;

proc sort data=mzprod04; by hhid; run;

* fertilizer cost - purchased; 
data tfert040; set tfert04; 
if trancost=0 then dtrancost=0; else dtrancost=1; 
if inputype<12 or 14<inputype<18 or inputype=21 or inputype=33 then fertcost04=inputpr*numpur; else fertcost04=.; 
if inputype=1 then dappr=inputpr; 
if punit=2 then dapri04=dappr;
if punit=2 then tranc04=trancost; 
if punit=5 then dapri04=dappr/5;
if punit=5 then tranc04=trancost/5;
if punit=6 then dapri04=dappr/10;
if punit=6 then tranc04=trancost/10;
if punit=7 then dapri04=dappr/25;
if punit=7 then tranc04=trancost/25;
if punit=11 then dapri04=dappr/50;
if punit=11 then tranc04=trancost/50;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then dapri04=.;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then tranc04=.;

if inputype=2 then mappr=inputpr; 
if punit=2 then mapri04=mappr;
if punit=5 then mapri04=mappr/5;
if punit=6 then mapri04=mappr/10;
if punit=7 then mapri04=mappr/25;
if punit=11 then mapri04=mappr/50;

if inputype=3 then tsppr=inputpr; 
if punit=2 then tspri04=tsppr;
if punit=5 then tspri04=tsppr/5;
if punit=6 then tspri04=tsppr/10;
if punit=7 then tspri04=tsppr/25;
if punit=11 then tspri04=tsppr/50;

if inputype=4 then ssppr=inputpr; 
if punit=2 then sspri04=ssppr;
if punit=5 then sspri04=ssppr/5;
if punit=6 then sspri04=ssppr/10;
if punit=7 then sspri04=ssppr/25;
if punit=11 then sspri04=ssppr/50;

if 4<inputype<8 then npkpr=inputpr; 
if punit=2 then npkri04=npkpr;
if punit=5 then npkri04=npkpr/5;
if punit=6 then npkri04=npkpr/10;
if punit=7 then npkri04=npkpr/25;
if punit=11 then npkri04=npkpr/50;

if inputype=8 then canpr=inputpr; 
if punit=2 then canri04=canpr;
if punit=5 then canri04=canpr/5;
if punit=6 then canri04=canpr/10;
if punit=7 then canri04=canpr/25;
if punit=11 then canri04=canpr/50;
*if punit=3 or punit=4 or 6<punit<11 or punit>11 then canri04=.;

if inputype=9 then asnpr=inputpr; 
if punit=2 then asnri04=asnpr;
if punit=5 then asnri04=asnpr/5;
if punit=6 then asnri04=asnpr/10;
if punit=7 then asnri04=asnpr/25;
if punit=11 then asnri04=asnpr/50;

if inputype=10 then ureapr=inputpr; 
if punit=2 then ureari04=ureapr;
if punit=5 then ureari04=ureapr/5;
if punit=6 then ureari04=ureapr/10;
if punit=7 then ureari04=ureapr/25;
if punit=11 then ureari04=ureapr/50;

proc means data=tfert040;  run; 
proc chart data=tfert040; hbar fertcost04; run;
proc sort data=tfert040; by hhid; run;
proc means MEAN sum data=tfert040 noprint; var fertcost04 
TRANC04 dtrancost; by hhid; output out=tfert04a mean= mfertcost04 mtranc04 mdtrancost sum=tfertcost04 stranc04 sdtrancost; run; 
proc means data=tfert04a; run; 
proc chart data=tfert04a; hbar mtranc04; where 0<mtranc04<2; run;
* fertilizer cost - credit; 
data cfert040; set input04; 
if input=1 then fertcred04=inpvalue*amtinput; else fertcred04=.; 
if fertcred04 ne .; 
proc means data=cfert040; where inpunit=2; run; 
proc sort data=cfert040; by input; run;
proc sort data=cfert040; by hhid; run;
proc means MEAN sum data=cfert040 noprint; var fertcred04; by hhid; 
output out=cfert04a mean= mfertcred04 sum=tfertcred04 ; run; 

*fertilizer prices;
data fprc04; set tfert040; keep dapri04 mapri04 tspri04 npkri04 canri04 ureari04 hhid; 
if dapri04=. then dapri04=29.3;
if mapri04=. then mapri04=24.1;
if tspri04=. then tspri04=25;
if npkri04=. then npkri04=25;
if canri04=. then canri04=25.1;
if ureari04=. then ureari04=25;

proc sort data=fprc04; by hhid; run;
proc means noprint mean data=fprc04; var dapri04 mapri04 tspri04 npkri04 canri04 ureari04 ; by hhid;
output out=mfprc04 mean=dapri04 mapri04 tspri04 npkri04 canri04 ureari04; run;
proc means data=mfprc04; run;
proc sort data=maxed04; by hhid; run;
data yld04; merge purch040 maxed04 mfprc04 mzprod04 ncrpf04 hh04a totac04 lstrev04 milk04 hhdemog04 laborac04 seed04 lprep04 mzprdat04 tfert04a cfert04a; by hhid;
if dmzpur04=. then dmzpur04=0; 
totfert=sum(of tdapkg04 tmapkg04 ttspkg04 tnpkkg04 tcankg04 tureakg04);
totfertac=totfert/acresm04; 
fertcst04=tvfert04;*dapri04*tdapkg04+mapri04*tmapkg04+tspri04*ttspkg04+tnpkkg04*npkri04+canri04*tcankg04
+tureakg04*ureari04;
fertcstac04=fertcst04/acresm04; 
if fertcstac04=. then fertcstac04=0; 
allfertac04=allfert04/acresm04;
if allfertac04=. then allfertac04=0; 
if sshy04>0 then hyb04=1; else hyb04=0; 
*acresm04=acm04;
yld04=mzprod04/acresm04; 
*fertac04=sfert/acresm04; 
if acresm04>0; 
IF 0<YLD04<10000; 
fertkgac04=fertkg04/acresm04;
fertaiac04=sfertai04/acresm04; 
if fertaiac04=. then fertaiac04=0; 
if fertkgac04=. then fertkgac04=0; 
*fertcstac04=fertcst04/acresm04;  
if lpcost04 ne . then lpcostac04=lpcost04/acresm04; else lpcostac04=0; 
seedkgac04=seedkg04/acresm04; 
*fhrsac04=famhrs04/acresm04;
*hhrsac04=hrhrs04/acresm04;
*hlcostac04=hlcost04/acresm04; 
div04=ncrpf04; 
*if fhrsac04<1000;
if fhrsac04=. then fhrsac04=0; 
*if hhrsac04<1000;
if hhrsac04=. then hhrsac04=0; 
*if hlcostac04<20000; 
if hlcostac04=. then hlcostac04=0; 
fertcac04=tfertcost04/acresm04; 
dapkgac04=tdapkg04/acresm04;
cankgac04=tcankg04/acresm04;
mapkgac04=tmapkg04/acresm04; 

proc means data=yld04; var tvfert04 mtranc04 dmzpur04 totfertac dapri04 mapri04 tspri04 npkri04 canri04 ureari04 tdapkg04 tmapkg04 
ttspkg04 tnpkkg04 tcankg04 tureakg04 allfertac04 sdvar04 educ04 fertcstac04 fertaiac04 
dapkgac04 cankgac04 mapkgac04 fertskm04 dmot04 dmat04 dext04 mzspr04 fertcac04 mmzpr04 yld04 div04 lpcostac04 seedkgac04 
acresm04 totacres04 HYB04 fertkgac04  fhrsac04 hhrsac04 hlcostac04 boy04 girl04 man04 wom04 oman04 hhsize04; *WHERE ACRESM04<10; run;

proc corr data=yld04; var fertkgac04 fertcstac04 fertaiac04; run;
proc chart data=yld04; hbar fertcstac04;*where fertcstac04<10000; run; 
proc means data=yld04; var fertcstac04; *where fertcstac04<10000; run;


proc plot data=yld04; plot fhrsac04*acresm04; run; 
proc chart data=yld04; hbar hlcostac04; run;
proc sort data=yld04; by div04; run; 
PROC export  DATA=yld04 OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\teg_yld04_4-8-18.xls' DBMS=xls REPLACE;
	SHEET='yld04'; run;


* 2007 data; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\input07.dta' out=input07 dbms = stata replace;
*proc means data=input07; run;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\purch07.dta' out=purch07 dbms = stata replace;
*proc means data=purch07; run;
data purch070; set purch07; 
if purch=1 then dmzpur07=1; 
if dmzpur07 ne .; 
keep hhid dmzpur07; 
run;
*proc means data=purch070; var dmzpur07 hhid; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\hh07.dta' out=hh07 dbms = stata replace;
*proc contents data=hh07; run;
*proc chart data=hh07; hbar nfermz/midpoints= 1 2 3 4 5 6 7 8 9 10 11 12; run;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\field07.dta' out=field07 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\croplev07.dta' out=croplev07 dbms = stata replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\fert07.dta' out=fert07 dbms = stata replace;

*proc means data=fert07;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\labour07.dta' out=labor07 dbms = stata replace;

*proc means data=labor07;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\maizeseed07.dta' out=mseed07 dbms = stata replace;

*proc means data=mseed07;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\demog07.dta' out=demog07 dbms = stata replace;

*proc means data=demog07;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\demoga07.dta' out=demoga07 dbms = stata replace;

*proc means data=demoga07;run;


proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\liveprod07.dta' out=lstprd07 dbms = stata replace;
*proc means data=lstprd07; run;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\cowmilk07.dta' out=cowmlk07 dbms = stata replace;
*proc means data=cowmlk07; run;

*proc means data=lstprd07 ;run;

*PROC CONTENTS DATA=FIELD07; RUN; 

proc sort data=field07; by hhid field;
proc sort data=croplev07; by hhid field; run;
proc sort data=fert07; by hhid field; run; 
proc sort data=lstprd07; by hhid; run; 

*proc means data=croplev07; run; 

data milk07; set cowmlk07; 
vmilk07=totmilk*price/2; 
if vmilk07=. then vmilk07=0; * value for 6 months;
cowmilk07=cowmilk; 
if vmilk07>0 then dmilk07=1; else dmilk07=0; 
if cowmilk>0; 
keep hhid vmilk07 cowmilk07; 
*proc means data=milk07; run; 

data lstrev070; set lstprd07; 
if liveprod>1;
vliv070=avgprod*6*price; 
if vliv070=. then vliv070=0;
proc means data=lstrev070 noprint; var vliv070; output out=lstrev07 sum=vliv07; by hhid; run;
*proc means data=lstrev07; run;  

*proc means data=mseed07; where harvest=1; run; 
data mseed070; set mseed07; where harvest=1; 

/*if units=1 then do; seedkg=qty; mzspr=price; end;
if units=2 then do; seedkg=qty*2; mzspr=price/2; end;
if units=9 then do; seedkg=qty*2; mzspr=price/2; end;
if units=3 then do; seedkg=qty*5; mzspr = price/5; end;
if units=4 then do; seedkg=qty*10;mzspr = price/10; end;
if units=5 then do; seedkg=qty*25;mzspr = price/25; end;*/
seedkg=kgseed; mzspr=totval/kgseed; 
/*proc means mean sum data=mseed070 sum noprint; var seedkg mzspr; output out=seed07 mean=mseedkg mzspr07 sum=seedkg07 smzspr; by hhid; run;*/
proc means mean sum data=mseed070 sum noprint; var seedkg mzspr sdvar sdtype; 
	output out=seed07 mean=mseedkg mzspr07 sdvar07 sdtype07 sum=seedkg07 smzspr ssdvar ssdtype; by hhid; run;
proc means data=seed07; run; 

proc sort data=labor07; by hhid field; run;* labor; 

/*data labor070; set labor07; 
manhrs=lb06; if manhrs=. then manhrs=0; 
womhrs=0.9*lb08; if womhrs=. then womhrs=0; 
chlhrs=0.775*lb10; if chlhrs=. then chlhrs=0; 
fhrs=sum(of manhrs womhrs chlhrs); 
hrhrs=5.1*lb01*lb02;
hlabwg=lb01*lb02*lb03;  
hlabcost=sum(of hlabwg lb07);
proc means data=labor070; run;

proc sort data=labor070; by hhid; run; 
proc means sum mean data=labor070 noprint; var fhrs hrhrs hlabcost ; by hhid ;  output out=slabor07 sum=famhrs07 hrhrs07 hlcost07; run;
proc means data=slabor07; run;
*/
*proc means data=demog07; run; 

data demog070; set demog07; * demog; 
if da02=1 and 15<age<40 then dman=1; else dman=0; 
if da02=1 and age>39 then doman=1; else doman=0; 
if da02=2 and age>15 then dwom=1; else dwom=0; 
if da02=1 and 5<age<16 then dboy=1; else dboy=0; 
if da02=2 and 5<age<16 then dgirl=1; else dgirl=0; 

proc means data=demog070 noprint sum n ; var dman doman dwom dboy dgirl ; output out=hhdemog070 sum = man07 oman07 wom07 boy07 girl07 n=hhsize07; by hhid; run;
*proc means data=hhdemog070; run; 

data hhdemog07; set hhdemog070; *merge hhdemoga07 hhdemogc07; *by hhid; 
if boy07=. then boy07=0;
if girl07=. then girl07=0;
if man07=. then man07=0;
if oman07=. then oman07=0;
if wom07=. then wom07=0;

*proc means data=hhdemog07; run;

data yld070; set croplev07 ; * maize production;
if crop=1 then harvkg=kgharv;
if crop=2 then harvkg=kgharv*.85;
*if crop<3;
if harvest=1;* and crop<3;
if sdtype=1 then hy07=1; else hy07=0;
IF CROP<3 THEN DMAIZE=1; ELSE DMAIZE=0; 
if slunit=1 then mzpr = price/90;
if slunit=2 then mzpr = price;
if slunit=3 then mzpr = price/50;
if slunit=9 then mzpr = price; 
if 3<slunit<9 or slunit >9 then mzpr = .;  
run;

proc sort data=yld070; by hhid;
proc sort data=allhhid07; by hhid; 
data mzprice07; merge yld070 allhhid07; by hhid; 
if dmaize=1; run;
proc sort data=mzprice07; by dist; run; 
proc means mean data=mzprice07 noprint; var mzpr; by dist; output out=mzpr_dist07 mean=mmzpr07; run;
*proc means data=mzpr_dist07; run; 
data distdat; set allhhid07; 
keep hhid dist; 
proc sort data=distdat; by dist; 
data mzprdat07; merge distdat mzpr_dist07; by dist; 
*proc means data=mzprdat07; run;  
proc sort data=mzprdat07; by hhid; 
run;

data field070; set field07;
if watersrc=1 then irrig=0; else irrig=1; 
if harvest=1;run;
*proc means data=field070; run; 
/*
data fert070; set fert07;
if harvest=1;
if fertotal=. then fertotal=0;  
*keep hhid field fertotal;
if ferttype =1 or ferttype=2 or ferttype=8 or ferttype=17 then fertot=fertotal; else fertot=0;; 
if 0<ferttype<12 or 14<ferttype<18 or 19<ferttype<25 then fertall=fertotal; else fertall=0;  
if ferttype=1 then dapkg=fertotal; else dapkg=0; 
if ferttype=2 then mapkg=fertotal; else mapkg=0; 
if ferttype=8 then cankg=fertotal; else cankg=0; 
if ferttype=17 then dcankg=fertotal; else dcankg=0; 
run;
*proc means data=fert070; run;

proc means data=fert070 noprint; var fertot dapkg mapkg cankg fertall; by hhid field; output out=fert07s sum=sfertot sdapkg smapkg scankg sfertall; run; 
*proc means data=fert07s; run;
*/
data fert070; set fert07;
if harvest=1;
if fertotal=. then fertotal=0;  
*keep hhid field fertotal;
if ferttype =1 or ferttype=2 or ferttype=8 /*or ferttype=17*/ then fertot=fertotal; else fertot=0;; 
if 0<ferttype<12 or 14<ferttype<18 or 19<ferttype<25 then allfert=fertotal; else allfert=0;  
if ferttype=1 then dapkg07=fertotal; else dapkg07=0; 
if ferttype=2 then mapkg07=fertotal; else mapkg07=0; 
if ferttype=3 then tspkg07=fertotal; else tspkg07=0; 
if 4<ferttype<8 then npkkg07=fertotal; else npkkg07=0; 
if ferttype=10 then ureakg07=fertotal; else ureakg07=0; 
if ferttype=8 then cankg07=fertotal; else cankg07=0; 
if dapkg07=. then dapkg07=0;
if mapkg07=. then mapkg07=0;
if cankg07=. then cankg07=0;
fertai=dapkg07*.38+cankg07*.27+mapkg07*.63;
if allfert=. then allfert=0; 
run;
proc means data=fert070; run;

proc means data=fert070 noprint; var fertot fertai dapkg07 
mapkg07 tspkg07 npkkg07 cankg07 ureakg07 allfert; by hhid field;
output out=fert07s sum=sfertot sfertai sdapkg07 smapkg07 stspkg07 snpkkg07 scankg07 sureakg07 sallfert; run; 
proc means data=fert07s; run;

proc sort data=yld070; by hhid field; run; * aggregate maize production;
proc means sum mean data=yld070 noprint; var harvkg sqt hy07 crop DMAIZE ; by hhid field;  output out=farmprod070 sum=sqprod ssqt shy07 scrop SDMAIZE; run;
proc means data=farmprod070; run;

proc sort data=farmprod070; by hhid field;
proc sort data=field070; by hhid field;
proc sort data=fert07s; by hhid field; 
data farmprod07; merge field070 fert07s farmprod070; by hhid field;
proc means data=farmprod07; run;

DATA MZ07; SET FARMPROD07; WHERE sqprod ne .; RUN; 

proc means sum data=mz07 noprint; var sqprod ssqt shy07 acres 
sfertot sdapkg07 smapkg07 stspkg07 snpkkg07 scankg07 sureakg07 sallfert lpcost; by hhid;  
output out=mzprod07 sum=mzprod07 ssqt07 sshy07 acresm07 
fertkg07 tdapkg07 tmapkg07 ttspkg07 tnpkkg07 tcankg07 tureakg07 allfert07 lpcost07; run;
proc means data=mzprod07; run; 

proc means sum data=mz07 noprint; var  lpcost; by hhid;  output out=lprep07 sum=lpcost07; where landprep>1; run; 
*proc means data=lprep07; run; 

* create vars for intercropping index; 

data idyld07; merge yld070 mz07; by  hhid field ; run;
proc means sum data=idyld07 noprint; var crop; by hhid field;  output out=ncrp070 n=ncrp07;  run;
*proc means data=ncrp070; run;
proc sort data=ncrp070; by hhid; run; 
proc means mean data=ncrp070 noprint; var ncrp07; by hhid; output out=ncrpf07 mean=ncrpf07; run; 

proc sort data=field070; by hhid; * total acres in all crops; 
proc means data=field070 sum noprint; var acres; by hhid; output out=totac07 sum=totacres07; run;
*proc means data=totac07; run;

data hh07a; set hh07;
fertskm07=fertskm;
dmot07=dmtroad;
dmat07=dm3stop;
dext07=dextn;
nfermz07=nfermz;
slope07=slope; 
if cash>0 then cred07=1; else cred07=0; 
keep hhid nfermz07 slope07 mthfin07 fertskm07 cred07 mlkprd dmot07 dmat07 dext07;

*proc means data=hh07a; run;
proc sort data=hh07a; by hhid; run;

proc sort data=mzprod07; by hhid; run;

* fertilizer cost; 
data tfert070; set input07; 
if inputype<12 or 14<inputype<18 /*or 19<inputype<25 or inputype=27 or inputype=28 or 
inputype=30 or inputype=43 or 57<inputype<62*/ then fertcost07=inputpr*numpur; else fertcost07=.; 
if inputype=1 then dappr=inputpr; 
if punit=2 then dapri07=dappr;
if punit=2 then tranc07=trancost; 
if punit=5 then dapri07=dappr/5;
if punit=5 then tranc07=trancost/5;
if punit=6 then dapri07=dappr/10;
if punit=6 then tranc07=trancost/10;
if punit=7 then dapri07=dappr/25;
if punit=7 then tranc07=trancost/25;
if punit=11 then dapri07=dappr/50;
if punit=11 then tranc07=trancost/50;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then dapri07=.;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then tranc07=.;

if inputype=2 then mappr=inputpr; 
if punit=2 then mapri07=mappr;
if punit=5 then mapri07=mappr/5;
if punit=6 then mapri07=mappr/10;
if punit=7 then mapri07=mappr/25;
if punit=11 then mapri07=mappr/50;

if inputype=3 then tsppr=inputpr; 
if punit=2 then tspri07=tsppr;
if punit=5 then tspri07=tsppr/5;
if punit=6 then tspri07=tsppr/10;
if punit=7 then tspri07=tsppr/25;
if punit=11 then tspri07=tsppr/50;

if inputype=4 then ssppr=inputpr; 
if punit=2 then sspri07=ssppr;
if punit=5 then sspri07=ssppr/5;
if punit=6 then sspri07=ssppr/10;
if punit=7 then sspri07=ssppr/25;
if punit=11 then sspri07=ssppr/50;

if 4<inputype<8 then npkpr=inputpr; 
if punit=2 then npkri07=npkpr;
if punit=5 then npkri07=npkpr/5;
if punit=6 then npkri07=npkpr/10;
if punit=7 then npkri07=npkpr/25;
if punit=11 then npkri07=npkpr/50;

if inputype=8 then canpr=inputpr; 
if punit=2 then canri07=canpr;
if punit=5 then canri07=canpr/5;
if punit=6 then canri07=canpr/10;
if punit=7 then canri07=canpr/25;
if punit=11 then canri07=canpr/50;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then canri07=.;

if inputype=9 then asnpr=inputpr; 
if punit=2 then asnri07=asnpr;
if punit=5 then asnri07=asnpr/5;
if punit=6 then asnri07=asnpr/10;
if punit=7 then asnri07=asnpr/25;
if punit=11 then asnri07=asnpr/50;

if inputype=10 then ureapr=inputpr; 
if punit=2 then ureari07=ureapr;
if punit=5 then ureari07=ureapr/5;
if punit=6 then ureari07=ureapr/10;
if punit=7 then ureari07=ureapr/25;
if punit=11 then ureari07=ureapr/50;

proc means data=tfert070;  run; 
proc sort data=tfert070; by hhid; run;
proc means MEAN sum data=tfert070 noprint; var fertcost07 TRANC07; by hhid; output out=tfert07a mean= mfertcost07 mtranc07 sum=tfertcost07 stranc07; run; 

data fprc07; set tfert070; keep dapri07 mapri07 tspri07 npkri07 canri07 ureari07 hhid; 
if dapri07=. then dapri07=37;
if mapri07=. then mapri07=31;
if tspri07=. then tspri07=25;
if npkri07=. then npkri07=29;
if canri07=. then canri07=34;
if ureari07=. then ureari07=32;

proc sort data=fprc07; by hhid; run;
proc means noprint mean data=fprc07; var dapri07 mapri07 tspri07 npkri07 canri07 ureari07 ; by hhid;
output out=mfprc07 mean=dapri07 mapri07 tspri07 npkri07 canri07 ureari07; run;
proc means data=mfprc07; run;

proc sort data=mzprod07; by hhid; 
proc sort data=ncrpf07; by hhid; 
proc sort data=hh07a; by hhid; 
proc sort data=totac07; by hhid; 
proc sort data=lstrev07; by hhid; 
proc sort data=milk07; by hhid;
proc sort data=hhdemog07; by hhid;
proc sort data=seed07; by hhid;
proc sort data=lprep07; by hhid;
proc sort data=mzprdat07; by hhid; run;
data yld07; merge mfprc07 purch070 mzprod07 ncrpf07 hh07a totac07 lstrev07 milk07 hhdemog07 /*slabor07*/ seed07 lprep07 mzprdat07 tfert07a; by hhid; 
fertcst07=dapri07*tdapkg07+mapri07*tmapkg07+tspri07*ttspkg07+tnpkkg07*npkri07+canri07*tcankg07
+tureakg07*ureari07;
fertcstac07=fertcst07/acresm07; 
if dmzpur07=. then dmzpur07=0; 
if sshy07>0 then hyb07=1; else hyb07=0; 
*acresm07=acm07;
yld07=mzprod07/acresm07; 
*fertac07=sfert/acresm07; 
if acresm07>0; 
IF 0<YLD07<10000; 
fertkgac07=fertkg07/acresm07;
if fertkgac07=. then fertkgac07=0; 
allfertac07=allfert07/acresm07;
if allfertac07=. then fertallac07=0; 
if lpcost07 ne . then lpcostac07=lpcost07/acresm07; else lpcostac07=0; 
seedkgac07=seedkg07/acresm07; 
fhrsac07=famhrs07/acresm07;
hhrsac07=hrhrs07/acresm07;
hlcostac07=hlcost07/acresm07; 
div07=ncrpf07; 
*if fhrsac07<1000;
if fhrsac07=. then fhrsac07=0; 
*if hhrsac07<1000;
if hhrsac07=. then hhrsac07=0; 
*if hlcostac07<20000; 
if hlcostac07=. then hlcostac07=0; 
fertcac07=fertcost07/acresm07; 

proc means data=yld07; var fertcstac07 dmzpur07 allfertac07 sdvar07 dmot07 dmat07 dext07 vmilk07 mmzpr07 yld07 div07 lpcostac07 seedkgac07 acresm07 totacres07 HYB07 fertkgac07 fertallac07 fhrsac07 hhrsac07 hlcostac07 boy07 girl07 man07 wom07 oman07 hhsize07; *WHERE ACRESM07<10; run;

proc plot data=yld07; plot fhrsac07*acresm07; run; 
proc chart data=yld07; hbar fertcstac07; where fertcstac07<30000;  run;
proc sort data=yld07; by div07; run; 
PROC export  DATA=yld07 OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\teg_yld07_1-11-18.xls' DBMS=XLS REPLACE;
	SHEET='yld07'; run;


* 2010 data;
 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\climate10.sav' out=climate10 dbms = spss replace;
proc means data=climate10; run;
proc chart data=climate10; hbar affct1; run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\lookup\cropconv.sav' out=cconv10 dbms = spss replace;
proc means data=cconv10; run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\purch10.sav' out=pur10 dbms = spss replace;
proc contents data=pur10; run; 

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\hh10.sav' out=hh10 dbms = spss replace;

proc means data=hh10; var mthfin10; run;
proc contents data=hh10; run; 
proc chart data=hh10; hbar nfermz/midpoints=1 2 3 4 5 6 7 8 9 10 11 12; run;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\field10.sav' out=field10 dbms = spss replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\croplev10.sav' out=croplev10 dbms = spss replace;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\fert10.sav' out=fert10 dbms = spss replace;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\input10.sav' out=input10 dbms = spss replace;

* maize purchases;
data pur10a; set pur10; 
if purch=1 and totqty>0 then mzpurch=1; else mzpurch=0; 
if purch=2 and totqty>0 then mzgift=1; else mzgift=0; 
if purch=3 and totqty>0 then mzmeal=1; else mzmeal=0; 
if totqty ne .; 
if totunit=1 then mzpurkg10=totqty*90;
if totunit=2 then mzpurkg10=totqty;
if totunit=19 then mzpurkg10=totqty;
if totunit=18 then mzpurkg10=totqty*2;
if totunit=11 then mzpurkg10=totqty*50;
if totunit=20 then mzpurkg10=totqty*5;
if totunit=8 then mzpurkg10=totqty*10;
if totunit=7 then mzpurkg10=totqty*25;
if totunit=9 then mzpurkg10=totqty*2;
if totunit=12 then mzpurkg10=totqty*4.35; *debe estimated from prices;
keep hhid mzpurkg10; 
proc sort data=pur10a; by hhid; 
proc means sum data=pur10a noprint; var mzpurkg10; by hhid; output out=pur10s sum=smzpurkg10; run; 
proc means data=pur10s; run;

data tran101; set input10; * trancost; 
if inputype<12;
if punit=2 then tran10=trancost;
if punit=7 then tran10=trancost/25;
if punit=8 then tran10=trancost/10;
if punit=9 then tran10=trancost;*gorogoro;
if punit=11 then tran10=trancost/50;
if trancost=0 then dtranc10=0; else dtranc10=1; 
proc means data=tran101; var punit tran10 dtranc10; run; 
proc chart data=tran101; hbar punit tran10; where dtranc10=1; run; 

*proc means data=fert10;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\labour10.sav' out=labor10 dbms = spss replace;

proc means data=labor10;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\maizeseed10.sav' out=mseed10 dbms = spss replace;

*proc means data=mseed10;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\demog10.sav' out=demog10 dbms = spss replace;

proc means data=demog10;run;

proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\demoga10.sav' out=demoga10 dbms = spss replace;

*proc means data=demoga10;run;


proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\liveprod10.sav' out=lstprd10 dbms = spss replace;
*proc means data=lstprd10; run;
proc import datafile='\\psf\Home\Documents\Tegemeo\data\Household survey 2010\data\cowmilk10.sav' out=cowmlk10 dbms = spss replace;
*proc means data=cowmlk10; run;

*proc means data=lstprd10 ;run;

*PROC CONTENTS DATA=FIELD10; RUN; 

proc sort data=field10; by hhid field;
proc sort data=croplev10; by hhid field; run;
proc sort data=fert10; by hhid field; run; 
proc sort data=lstprd10; by hhid; run; 

*proc means data=croplev10; run; 

data milk10; set cowmlk10; 
vmilk10=totmilkv/2; 
if vmilk10=. then vmilk10=0; * value for 6 months;
if milk=1;
keep hhid vmilk10; 
proc means data=milk10; run; 

data lstrev100; set lstprd10; 
if liveprod>1;
vliv100=avgprod*6*price; 
if vliv100=. then vliv100=0;
proc means data=lstrev100 noprint; var vliv100; output out=lstrev10 sum=vliv10; by hhid; run;
proc means data=lstrev10; run;  

proc means data=mseed10; where harvest=1; run; 
data mseed100; set mseed10; where harvest=1; 

/*if units=1 then do; seedkg=qty; mzspr=price; end;
if units=2 then do; seedkg=qty*2; mzspr=price/2; end;
if units=9 then do; seedkg=qty*2; mzspr=price/2; end;
if units=3 then do; seedkg=qty*5; mzspr = price/5; end;
if units=4 then do; seedkg=qty*10;mzspr = price/10; end;
if units=5 then do; seedkg=qty*25;mzspr = price/25; end;*/
seedkg=kgseed; mzspr=totval/kgseed; 
/*proc means mean sum data=mseed100 sum noprint; var seedkg mzspr; output out=seed10 mean=mseedkg mzspr10 sum=seedkg10 smzspr; by hhid; run;*/
proc means mean sum data=mseed100 sum noprint; var seedkg mzspr sdvar sdtype; output out=seed10 mean=mseedkg mzspr10 sdvar10 sdtype10 sum=seedkg10 smzspr ssdvar ssdtype; by hhid; run;
proc means data=seed10; run; 

proc sort data=labor10; by hhid field; run;* labor; 

/*data labor100; set labor10; 
manhrs=lb06; if manhrs=. then manhrs=0; 
womhrs=0.9*lb08; if womhrs=. then womhrs=0; 
chlhrs=0.775*lb10; if chlhrs=. then chlhrs=0; 
fhrs=sum(of manhrs womhrs chlhrs); 
hrhrs=5.1*lb01*lb02;
hlabwg=lb01*lb02*lb03;  
hlabcost=sum(of hlabwg lb10);
proc means data=labor100; run;

proc sort data=labor100; by hhid; run; 
proc means sum mean data=labor100 noprint; var fhrs hrhrs hlabcost ; by hhid ;  output out=slabor10 sum=famhrs10 hrhrs10 hlcost10; run;
proc means data=slabor10; run;
*/
proc means data=demog10; run; 

data demog100; set demog10; * demog; 
if da02=1 and 15<age<40 then dman=1; else dman=0; 
if da02=1 and age>39 then doman=1; else doman=0; 
if da02=2 and age>15 then dwom=1; else dwom=0; 
if da02=1 and 5<age<16 then dboy=1; else dboy=0; 
if da02=2 and 5<age<16 then dgirl=1; else dgirl=0; 

proc means data=demog100 noprint sum n ; var dman doman dwom dboy dgirl ; output out=hhdemog100 sum = man10 oman10 wom10 boy10 girl10 n=hhsize10; by hhid; run;
proc means data=hhdemog100; run; 

data hhdemog10; set hhdemog100; *merge hhdemoga10 hhdemogc10; *by hhid; 
if boy10=. then boy10=0;
if girl10=. then girl10=0;
if man10=. then man10=0;
if oman10=. then oman10=0;
if wom10=. then wom10=0;

proc means data=hhdemog10; run;

data cconv100; set cconv10;
hunit=unit; 
if crop<3; 
proc sort data=cconv100; by crop hunit;
run;
proc sort data=croplev10; by crop hunit;
run;
proc means data=cconv100; run;

data croplev10c; merge cconv100 croplev10; by crop hunit; 
run;

data yld100; set croplev10c ; * maize production;
kgharv=hvt*kgconver;
if crop=1 then harvkg=kgharv;
if crop=2 then harvkg=kgharv*.85;
*if crop<3;
if harvest=1;* and crop<3;
if sdtype=1 then hy10=1; else hy10=0;
IF CROP<3 THEN DMAIZE=1; ELSE DMAIZE=0; 
if slunit=1 then mzpr = price/90;
if slunit=2 then mzpr = price;
if slunit=3 then mzpr = price/50;
if slunit=9 then mzpr = price; 
if 3<slunit<9 or slunit >9 then mzpr = .;  
*keep hhid hvt hunit slunit kgconver dmaize harvkg; 
run;
proc means data=yld100; where dmaize = 1; run; 

proc sort data=yld100; by hhid;
proc sort data=allhhid07; by hhid; 
data mzprice10; merge yld100 allhhid07; by hhid; 
if dmaize=1; run;
proc sort data=mzprice10; by dist; run; 
proc means mean data=mzprice10 noprint; var mzpr; by dist; output out=mzpr_dist10 mean=mmzpr10; run;
proc means data=mzpr_dist10; run; 
data distdat; set allhhid07; 
keep hhid dist; 
proc sort data=distdat; by dist; 
data mzprdat10; merge distdat mzpr_dist10; by dist; 
proc means data=mzprdat10; run;  
proc sort data=mzprdat10; by hhid; 
run;

data field100; set field10;
if watersrc=1 then irrig=0; else irrig=1; 
if harvest=1;run;
proc means data=field100; run; 

data fert100; set fert10;
if harvest=1;
if fertotal=. then fertotal=0;  
*keep hhid field fertotal;
if ferttype =1 or ferttype=2 or ferttype=8 or ferttype=17 then fertot=fertotal; else fertot=0;; 
if 0<ferttype<12 or 14<ferttype<18 or 19<ferttype<25 then fertall=fertotal; else fertall=0;  
if ferttype=1 then dapkg=fertotal; else dapkg=0; 
if ferttype=2 then mapkg=fertotal; else mapkg=0; 
if ferttype=8 then cankg=fertotal; else cankg=0; 
if ferttype=17 then dcankg=fertotal; else dcankg=0; 
run;
proc means data=fert100; run;

proc means data=fert100 noprint; var fertot dapkg mapkg cankg fertall; by hhid field; output out=fert10s sum=sfertot sdapkg smapkg scankg sfertall; run; 
proc means data=fert10s; run;

proc sort data=yld100; by hhid field; run; * aggregate maize production;
proc means sum mean data=yld100 noprint; var harvkg sqt hy10 crop DMAIZE ; by hhid field;  output out=farmprod100 sum=sqprod ssqt shy10 scrop SDMAIZE; run;
proc means data=farmprod100; run;

proc sort data=farmprod100; by hhid field;
proc sort data=field100; by hhid field;
proc sort data=fert10s; by hhid field; 
data farmprod10; merge field100 fert10s farmprod100; by hhid field;
*proc means data=farmprod10; run;

DATA MZ10; SET FARMPROD10; WHERE sqprod ne .; RUN; 

proc means sum data=mz10 noprint; var sqprod ssqt shy10 acres sfertot sdapkg smapkg scankg sfertall lpcost; by hhid;  
output out=mzprod10 sum=mzprod10 ssqt10 sshy10 acresm10 fertkg10 dapkg10 mapkg10 cankg10 fertall10 lpcost10; run;
proc means data=mzprod10; run; 

proc means sum data=mz10 noprint; var  lpcost; by hhid;  output out=lprep10 sum=lpcost10; where landprep>1; run; 
proc means data=lprep10; run; 

* create vars for intercropping index; 

data idyld10; merge yld100 mz10; by  hhid field ; run;
proc means sum data=idyld10 noprint; var crop; by hhid field;  output out=ncrp100 n=ncrp10;  run;
proc means data=ncrp100; run;
proc sort data=ncrp100; by hhid; run; 
proc means mean data=ncrp100 noprint; var ncrp10; by hhid; output out=ncrpf10 mean=ncrpf10; run; 
proc means data=ncrpf10; run;

proc sort data=field100; by hhid; * total acres in all crops; 
proc means data=field100 sum noprint; var acres; by hhid; output out=totac10 sum=totacres10; run;
proc means data=totac10; run;

data hh10a; set hh10;
slope10=slope; 
nfermz10=nfermz; 
fertskm10=fertskm;
dmot10=dmtroad;
*dmat10=dm3stop;*not included in 2010; 
dext10=dextn;
if cash>0 then cred10=1; else cred10=0; 
keep hhid slope10 nfermz10 fertskm10 cred10 mlkprd dmot10 dext10;
proc sort data=hh10a; by hhid; run;

proc sort data=mzprod10; by hhid; run;
/*
* fertilizer cost; 
data tfert100; set tfert10; 

if inputype<11 or 14<inputype<18 or inputype=21 or inputype=33 then fertcost10=inputpr*numpur; else fertcost10=.; 

if inputype=1 then dappr=inputpr; 
if punit=2 then dapri10=dappr;
if punit=2 then tranc10=trancost; 
if punit=5 then dapri10=dappr/5;
if punit=5 then tranc10=trancost/5;
if punit=6 then dapri10=dappr/10;
if punit=6 then tranc10=trancost/10;
if punit=7 then dapri10=dappr/25;
if punit=7 then tranc10=trancost/25;
if punit=11 then dapri10=dappr/50;
if punit=11 then tranc10=trancost/50;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then dapri10=.;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then tranc10=.;

if inputype=2 then mappr=inputpr; 
if punit=2 then mapri10=mappr;
if punit=5 then mapri10=mappr/5;
if punit=6 then mapri10=mappr/10;
if punit=7 then mapri10=mappr/25;
if punit=11 then mapri10=mappr/50;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then mapri10=.;

if inputype=8 then canpr=inputpr; 
if punit=2 then canri10=canpr;
if punit=5 then canri10=canpr/5;
if punit=6 then canri10=canpr/10;
if punit=7 then canri10=canpr/25;
if punit=11 then canri10=canpr/50;
if punit=3 or punit=4 or 6<punit<11 or punit>11 then canri10=.;

proc means data=tfert100; *where dappr ne .; run; 
proc sort data=tfert100; by hhid; 
*/

proc sort data=mzprod10; by hhid; 
proc sort data=ncrpf10; by hhid; 
proc sort data=hh10a; by hhid; 
proc sort data=totac10; by hhid; 
proc sort data=lstrev10; by hhid; 
proc sort data=milk10; by hhid;
proc sort data=hhdemog10; by hhid;
proc sort data=seed10; by hhid;
proc sort data=lprep10; by hhid;
proc sort data=mzprdat10; by hhid; 
proc sort data=pur10s; by hhid; 
 
data yld10; merge pur10s mzprod10 ncrpf10 hh10a totac10 lstrev10 milk10 hhdemog10 /*slabor10*/ seed10 lprep10 mzprdat10 /*tfert100*/; by hhid; 
if smzpurkg10>0 then dmzpur10=1; else dmzpur10=0;
if sshy10>0 then hyb10=1; else hyb10=0; 
*acresm10=acm10;
yld10=mzprod10/acresm10; 
*fertac10=sfert/acresm10; 
if acresm10>0; 
IF 0<YLD10<10000; 
fertkgac10=fertkg10/acresm10;
if fertkgac10=. then fertkgac10=0; 
allfertac10=fertall10/acresm10;
if fertallac10=. then fertallac10=0; 
if lpcost10 ne . then lpcostac10=lpcost10/acresm10; else lpcostac10=0; 
seedkgac10=seedkg10/acresm10; 
fhrsac10=famhrs10/acresm10;
hhrsac10=hrhrs10/acresm10;
hlcostac10=hlcost10/acresm10; 
div10=ncrpf10; 
*if fhrsac10<1000;
if fhrsac10=. then fhrsac10=0; 
*if hhrsac10<1000;
if hhrsac10=. then hhrsac10=0; 
*if hlcostac10<20000; 
if hlcostac10=. then hlcostac10=0; 
fertcac10=fertcost10/acresm10; 
year=2010; 
*proc means data=milk10; run; 
proc means data=yld10; var allfertac10 dmzpur10 sdvar10 dmot10 dext10 vmilk10 mmzpr10 yld10 div10 lpcostac10 seedkgac10 acresm10 totacres10 HYB10 fertkgac10 fertallac10 fhrsac10 hhrsac10 hlcostac10 boy10 girl10 man10 wom10 oman10 hhsize10; *WHERE ACRESM10<10; run;

proc plot data=yld10; plot fhrsac10*acresm10; run; 
proc chart data=yld10; hbar yld10; run;
proc sort data=yld10; by div10; run; 
PROC export  DATA=yld10 OUTfile='\\psf\Home\Documents\Tegemeo\data\K07_data_stata\teg_yld10_1-11-18.xls' DBMS=XLS REPLACE;
	SHEET='yld10'; run;


