]
*switchers; 
data pan1s; set pan1; 
if 10<yld<7500;
*if dlow=1;
*if ((hfn=1) or (hyb=1 and hfs=1));
if switch1=1; 
if seedac<35; 
if fertac<600; 
*if year=1997 or year=2004; 
run; 
proc model  data=pan1s;  *and (year=1997 or year=2004); 
yld = (1-hyb)*(exp(b0 + bdl*dlow + bdh*dhigh + bd00*d00 + bd04*d04 + bd07*d07 + bd10*d10
/*+ adpr1*dprov1 + adpr3*dprov3 + adpr4*dprov4 + adpr5*dprov5 + adpr6*dprov6*/
 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld)) 
+ hyb*(exp(hb0 + hbdl*dlow + hbdh*dhigh + hbd00*d00 + hbd04*d04 + hbd07*d07 + hbd10*d10
/*+ hadpr1*dprov1 + hadpr3*dprov3 + hadpr4*dprov4 + hadpr5*dprov5 + hadpr6*dprov6*/
 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac)  + hay*layld));

ynn = exp(b0 + bdl*dlow + bdh*dhigh + bd00*d00 + bd04*d04 + bd07*d07 + bd10*d10
/*+ adpr1*dprov1 + adpr3*dprov3 + adpr4*dprov4 + adpr5*dprov5 + adpr6*dprov6*/
 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
yhn = exp(hb0 + hbdl*dlow + hbdh*dhigh + hbd00*d00 + hbd04*d04 + hbd07*d07 + hbd10*d10 
/*+ hadpr1*dprov1 + hadpr3*dprov3 + hadpr4*dprov4 + hadpr5*dprov5 + hadpr6*dprov6*/
+ hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac) + hay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
dlow=dlow;
dhigh=dhigh; 
hhid=hhid;
year=year; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=ress; run; 
solve ynn yhn /out=oyldps; run;
data oylds; set oyldps;
bhybpa=100*(log(yhn)-log(ynn));
retcs=yhn-ynn; 
if -500<retcs<600; 
proc means data=oylds; var yhn ynn retcs; run;
proc means data=oylds; var yhn ynn retcs; where hyb=1; run;
proc means data=oylds; var yhn ynn retcs; where hyb=0; run;
proc chart data=oylds; hbar retcs; run;

data ress1; set ress;
res=yld;
res2=(res)**2;
if -1200<res<1400; 
proc chart data=ress1; hbar res res2;
run;

data ress10; set ress1; where hyb=0; 
res20=res2; 
res0=res;
if res20<1; 
data ress11; set ress1; where hyb=1; 
res21=res2; 
res1=res;
if res21<1; 
data ress110; merge ress10 ress11; 
label res0='Transitory';
label res1=''; 
run;
proc chart data=ress110; hbar res20 res21; run;
proc sgplot data=ress110; 
density res0/type=kernel legendlabel='Non-Hybrid' lineattrs=(color=black);
density res1/type=kernel legendlabel='Hybrid' lineattrs=(color=black);
run; 

proc model  data=ress1; where res<0; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
hhid=hhid;
year=year; 
fit res2/hccme=3 outpredict out=pred2s;
run; 
proc sort data=pred2s; by hhid year; run;
proc sort data=oylds; by hhid year; run;
data oyldsp2; merge pred2s oylds; by hhid year; 
res2=(res2)**.5; 
if retcs>100 then cvs=res2/retcs; 
label retcs="Expected Hybrid Returns (kg/ac)";
label res2="Downside Risk (kg/ac)";
label cvs="Normalized Downside Risk (%)"; 
run;
proc means data=oyldsp2; var res2; run;
proc sgplot data=oyldsp2; 
scatter x=retcs y=res2; where retcs>0;* and res2<250 ; run;

proc model data=oyldsp2; where retcs>0 ; 
res2 = a + b*(retcs) + c*hyb*retcs ; 
fit res2; 
run;

proc model  data=ress1; where res>=0; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
hhid=hhid;
year=year; 
fit res2/hccme=3 outpredict out=pred2s;
run; 
proc sort data=pred2s; by hhid year; run;
proc sort data=oylds; by hhid year; run;
data oyldsp2; merge pred2s oylds; by hhid year; 
res2=(res2)**.5; 
if retcs>100 then cvs=res2/retcs; 
label retcs="Expected Hybrid Returns (kg/ac)";
label res2="Upside Risk (kg/ac)";
label cvs="Normalized Upside Risk (%)"; 
run;
proc means data=oyldsp2; var res2; run;
proc sgplot data=oyldsp2; 
scatter x=retcs y=res2; where retcs>0;* and res2<250 ; run;

proc model data=oyldsp2; where retcs>0 ; 
res2 = a + b*(retcs) + c*hyb*retcs ; 
fit res2; 
run;

* low zone; 
data pan1l; set pan1; 
if 10<yld<2000;
if dlow=1;
if ((hfn=1) or (hyb=1 and hfs=1));
*if year=1997 or year=2004; 
*if year >2004; 
if seedac<35; 
if fertac<600; 
run; 
proc model  data=pan1l;  *and (year=1997 or year=2004); 
yld = hfn*(exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit) + adf*(1-dfert) + afrt*log(1-dfert+fertac)*/ + asd*log(seedac) + ay*layld)) 
+ hyb*hfs*(exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac)  + hay*layld));

ynn = exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)+ adf*(1-dfert) + afrt*log(1-dfert+fertac)*/ + asd*log(seedac) + ay*layld); 
yhn = exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac) + hay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
dlow=dlow;
dhigh=dhigh; 
hhid=hhid; 
year=year; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=resl; run; 
solve ynn yhn /out=oyldpl; run;
data oyldl; set oyldpl;
bhybpa=100*(log(yhn)-log(ynn));
retcl=yhn-ynn; 
if -500<retcl<600; 
proc means data=oyldl; var yhn ynn retcl; run;
proc chart data=oyldl; hbar retcl; run;

data resl1; set resl;
res=yld;
res2=(res)**2;
*if -1200<res<900; 
run;
proc chart data=resl1; hbar res res2;
run;

data resl10; set resl1; where hyb=0; 
res20=res2; 
res0=res;
*if res20<1; 
data resl11; set resl1; where hyb=1; 
res21=res2; 
res1=res;
*if res21<1; 
data resl110; merge resl10 resl11; 
label res0='Low Zone';
label res1=''; 
run;
proc chart data=resl110; hbar res20 res21; run;
proc sgplot data=resl110; 
density res0/type=kernel legendlabel='Non-Hybrid' lineattrs=(color=black);
density res1/type=kernel legendlabel='Hybrid' lineattrs=(color=black);
run; 


proc model  data=resl1; where res<0;* and res2<300000; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac)+ ay*layld ); 
hhid=hhid;
year=year; 
fit res2/hccme=3 outpredict out=pred2l;
run; 
proc sort data=pred2l; by hhid year; run;
proc sort data=oyldl; by hhid year; run;
data oyldlp2; merge pred2l oyldl; by hhid year; 
res2=(res2)**.5; 
lres2=log(res2); 
if retcl>100 then cvs=res2/retcl; 
label retcl="Expected Hybrid Returns (kg/ac)";
label res2="Downside Risk (kg/ac)";
label cvs="Normalized Downside Risk (%)";
label hyb="Hybrid"; 
run;
proc means data=oyldlp2; var res2; run;

proc sgplot data=oyldlp2; 
scatter x=retcl y=res2/ group=hyb markerattrs=(color=black);where retcl>0; * and res2<250 ; run;

proc model data=oyldlp2; where retcl>0 ; 
res2 = a + b*(retcl) + c*hyb ;*+ d*hyb*retcl ; 
fit res2; 
run;

data oyldlp2n; set oyldlp2;
if hyb=0; 
if retcl>0; 
res2n=res2; retcln=retcl;
if res2n ne .; 
keep res2n retcln;
run;
data oyldlp2h; set oyldlp2;
if hyb=1; 
if retcl>0; 
res2h=res2; retclh=retcl;
if res2h ne .; 
keep res2h retclh;
run;
data oyldlp2nh; set oyldlp2n oyldlp2h; 
run;

proc means data=oyldlp2nh; run;
proc sgplot data=oyldlp2nh; 
scatter y=res2n x=retcln/color=black;
scatter y=res2h x=retclh/color=black; 
run;

proc model  data=resl1; where res>0; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
hhid=hhid;
year=year; 
fit res2/hccme=3 outpredict out=pred2l;
run; 
proc sort data=pred2l; by hhid year; run;
proc sort data=oyldl; by hhid year; run;
data oyldlp2; merge pred2l oyldl; by hhid year; 
res2=res2**.5; 
label retcl="Hybrid Returns (kg/ac)";
label res2="Upside Risk (kg/ac)";
label hyb="Hybrid";
run;
proc means data=oyldlp2; var res2; run;

proc sgplot data=oyldlp2; 
scatter x=retcl y=res2/ group=hyb markerattrs=(color=black);where retcl>0; * and res2<250 ; run;

proc model data=oyldlp2; where retcl>0 ; 
res2 = a + b*retcl + c*hyb ;*+ d*hyb*retcl; 
fit res2; 
run;

* med zone; 

* med, perm hyb use vs trans non-use; 
proc means data=pan1; var yld; where hfsn=1 and dmed=1; run;
proc means data=pan1; var yld; where hybp=1 and dmed=1; run;

proc model  data=pan1; where 40<yld<7500 and dmed=1 and ((hfsn=1) or hybp=1)
AND seedac<35 and fertac<600;   
yld = hfsn*(exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit)*/ /*+ hadf*(1-dfert) + hafrt*log(1-dfert+fertac)*/ + hasd*log(seedac)  + hay*layld))
+ hybp*(exp(fhb0  + fhbd00*d00 + fhbd04*d04 + fhbd07*d07 
+ fhbd10*d10 + fhacm*log(acresm) + fhatot*ltotac + fham*log(main) + fhadmilk*dmilk + fhainter*inter + fhadoub*doub + fhahhsz*hhsize
+ fhaxt*log(annxt)  /*+ fhait*log(annit)*/ + fhadf*(1-dfert) + fhafrt*log(1-dfert+fertac) + fhasd*log(seedac)  + fhay*layld)); ; 

yhn = exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)*/
/*+ hadf*(1-dfert) + hafrt*log(1-dfert+fertac)*/ + hasd*log(seedac) + hay*layld);
yhf = exp(fhb0  + fhbd00*d00 + fhbd04*d04 + fhbd07*d07 
+ fhbd10*d10 + fhacm*log(acresm) + fhatot*ltotac + fham*log(main) + fhadmilk*dmilk + fhainter*inter + fhadoub*doub + fhahhsz*hhsize
+ fhaxt*log(annxt)  /*+ fhait*log(annit) */
+ fhadf*(1-dfert) + fhafrt*log(1-dfert+fertac) + fhasd*log(seedac)  + fhay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
hyb=hyb; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=resm; run; 
solve yhf yhn /out=oyldpm; run;

data oyldm; set oyldpm;
bhybpa=100*(log(yhn)-log(yhf));
retcm=yhf-yhn; 
if -500<retcm<1500; 
proc means data=oyldm; var hfsn hybp yhn yhf retcm; run;
proc chart data=oyldm; hbar retcm; run;

data resm10; set resm1; where hyb=0; 
res20=res2; 
res0=res;
*if res20<1; 
data resm11; set resm1; where hyb=1; 
res21=res2; 
res1=res;
*if res21<1; 
data resm110; merge resm10 resm11; 
label res0='Medium Zone';
label res1=''; 
run;
proc chart data=resm110; hbar res20 res21; run;
proc sgplot data=resm110; 
density res0/type=kernel legendlabel='Non-Hybrid' lineattrs=(color=black);
density res1/type=kernel legendlabel='Hybrid' lineattrs=(color=black);
run; 

proc model  data=resm1; where res<0; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac)+ ay*layld ); 
fit res2/hccme=3;
run; 
proc model  data=resm1; where res>=0; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac)+ ay*layld); 
fit res2/hccme=3;
run; 

* high zone; 
proc means data=pan1; var hfs hfp hfn; where dhigh=1; run;

proc model  data=pan1; where 100<yld and dhigh=1 
and ((hfs=1 and hyb=0) or hyball=1) and seedac<35 and fertac<600; 
yld = hfs*(1-hyb)*(exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld)) 
+ hyball*(exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt)  /*+ hait*log(annit)*/+ hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac)  + hay*layld));

ynn = exp(b0  + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
yhn = exp(hb0  + hbd00*d00 + hbd04*d04 + hbd07*d07 
+ hbd10*d10 + hacm*log(acresm) + hatot*ltotac + ham*log(main) + hadmilk*dmilk + hainter*inter + hadoub*doub + hahhsz*hhsize
+ haxt*log(annxt) /*+ hait*log(annit)*/ + hadf*(1-dfert) + hafrt*log(1-dfert+fertac) + hasd*log(seedac) + hay*layld);

nsnhl=nsnhl; 
fkm=fkm;
cred=cred; 
dmot=dmot;
dext=dext; 
hyball=hyball;
hybnon=hybnon;
switch1=switch1;
dmed=dmed;  
dlow=dlow;
dhigh=dhigh; 
hhid=hhid;
year=year; 
*test ynrm-yhrm;
*test ynrm-yhrsm;
*test yhrm-yhrsm; 
*test    bd00, bd04, bd07,bd10, acm, atot, am, admilk, ainter, adoub, ahhsz, axt, ait; 
*test  hbd00, hbd04, hbd07,hbd10, hacm, hatot, ham, hadmilk, hainter, hadoub, hahhsz, haxt, hait; 
*test  b0=hb0, bd00=hbd00, bd04=hbd04, bd07=hbd07,bd10=hbd10, acm=hacm, atot=hatot, 
am=ham, admilk=hadmilk, ainter=hainter, adoub=hadoub, ahhsz=hahhsz, axt=haxt, ait=hait; 
fit yld/hccme=3 outresid out=resh; run; 
solve ynn yhn /out=oyldph; run;
data oyldh; set oyldph;
bhybpa=100*(log(yhn)-log(ynn));
retch=yhn-ynn; 
if -300<retch<2500; 
proc means data=oyldh; var yhn ynn retch; run;
proc chart data=oyldh; hbar retch; run;

data oylmhs; merge oyldh oyldm oyldl oylds; 
label retch="Hybrid Returns (kg/ac)";
run;
proc means data=oylmhs; var retcl retcm retch retcs;  run;

proc sgplot data=oylmhs; 
xaxis min=-500 max=1500; 
histogram retch;*/type = kernel legendlabel='Permanent Adopters - High' lineattrs=(color=black);
density retcm/type = kernel legendlabel='Permanent Adopters - Medium' lineattrs=(color=black);
density retcl/type = kernel legendlabel='Permanent Non-Adopters - Low' lineattrs=(color=black);
density retcs/type = kernel legendlabel='Transitory' lineattrs=(color=black);
run;

data resh1; set resh;
res=yld;
res2=(res)**2;
if -1200<res<2000; 
proc chart data=resh1; hbar res res2;
run;

data resh10; set resh1; where hyb=0; 
res20=res2; 
res0=res;
*if res20<1; 
data resh11; set resh1; where hyb=1; 
res21=res2; 
res1=res;
*if res21<1; 
data resh110; merge resh10 resh11; 
label res0='High Zone';
label res1=''; 
run;
proc chart data=resh110; hbar res20 res21; run;
proc sgplot data=resh110; 
density res0/type=kernel legendlabel='Non-Hybrid' lineattrs=(color=black);
density res1/type=kernel legendlabel='Hybrid' lineattrs=(color=black);
run; 

proc model  data=resh1; where res<0; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac) + ay*layld); 
hhid=hhid;
year=year; 
fit res2/hccme=3 outpredict out=pred2h;
run; 
proc sort data=pred2h; by hhid year; run;
proc sort data=oyldh; by hhid year; run;
data oyldhp2n; merge pred2h oyldh; by hhid year; 
res2n=(res2)**.5; 
label retch="Expected Hybrid Returns (kg/ac)";
label res2n="Downside Risk (kg/ac)";
run;
proc means data=oyldhp2n; var retch res2n; run;
proc chart data=oyldhp2n; hbar res2; run; 

proc sgplot data=oyldhp2n; 
scatter x=retch y=res2n/ group=hyb markerattrs=(color=black);*where retch<400; * and res2<250 ; run;

proc model data=oyldhp2n; where retch<200;
res2n = a + b*retch + c*hyb + d*hyb*retch; 
fit res2n; 
run;

proc model  data=resh1; where res>=0; 
res2 = exp(b0 + bhyb*hyb + bd00*d00 + bd04*d04 + bd07*d07 
+ bd10*d10 + acm*log(acresm) + atot*ltotac + am*log(main) + admilk*dmilk + ainter*inter + adoub*doub + ahhsz*hhsize
+ axt*log(annxt) /*+ ait*log(annit)*/ + adf*(1-dfert) + afrt*log(1-dfert+fertac) + asd*log(seedac)+ ay*layld ); 
hhid=hhid;
year=year; 
fit res2/hccme=3 outpredict out=pred2h;
run; 
proc sort data=pred2h; by hhid year; run;
proc sort data=oyldh; by hhid year; run;
data oyldhp2p; merge pred2h oyldh; by hhid year; 
res2p=(res2)**.5; 
label retch="Hybrid Returns (kg/ac)";
label res2p="Upside Risk";
run;
proc means data=oyldhp2p; var retch res2p; run;

proc sgplot data=oyldhp2p; 
scatter x=retch y=res2p/ group=hyb markerattrs=(color=black);*where retch<400; * and res2<250 ; run;

proc model data=oyldhp2p; *where retch<100  ; 
res2p = a + b*retch + c*hyb ;*+ d*hyb*retch; 
fit res2p; 
run;

